/* Init.c generated by valac 0.56.17, the Vala compiler
 * generated from Init.vala, do not modify */

/*
 * Copyright 2021 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include <glib.h>
#include <gtk/gtk.h>
#include "granite-7.h"
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define GRANITE_GETTEXT_PACKAGE "granite-7"
#define GRANITE_LOCALEDIR "/usr/share/locale"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

VALA_EXTERN gboolean granite_initialized;
gboolean granite_initialized = FALSE;
VALA_EXTERN GtkCssProvider* granite_base_provider;
GtkCssProvider* granite_base_provider = NULL;
VALA_EXTERN GtkCssProvider* granite_app_provider;
GtkCssProvider* granite_app_provider = NULL;

 G_GNUC_INTERNAL void granite_register_display (GdkDisplay* display);
static void _granite_register_display_gdk_display_manager_display_opened (GdkDisplayManager* _sender,
                                                                   GdkDisplay* display,
                                                                   gpointer self);
 G_GNUC_INTERNAL GtkCssProvider* granite_init_provider_from_file (GFile* file);

static void
_granite_register_display_gdk_display_manager_display_opened (GdkDisplayManager* _sender,
                                                              GdkDisplay* display,
                                                              gpointer self)
{
#line 26 "../lib/Init.vala"
	granite_register_display (display);
#line 54 "Init.c"
}

void
granite_init (void)
{
	GdkDisplayManager* display_manager = NULL;
	GdkDisplayManager* _tmp0_;
	GdkDisplayManager* _tmp1_;
	GdkDisplayManager* _tmp2_;
	GSList* _tmp3_;
#line 19 "../lib/Init.vala"
	if (granite_initialized) {
#line 20 "../lib/Init.vala"
		return;
#line 69 "Init.c"
	}
#line 23 "../lib/Init.vala"
	g_type_ensure (GRANITE_TYPE_SETTINGS);
#line 25 "../lib/Init.vala"
	_tmp0_ = gdk_display_manager_get ();
#line 25 "../lib/Init.vala"
	display_manager = _tmp0_;
#line 26 "../lib/Init.vala"
	_tmp1_ = display_manager;
#line 26 "../lib/Init.vala"
	g_signal_connect (_tmp1_, "display-opened", (GCallback) _granite_register_display_gdk_display_manager_display_opened, NULL);
#line 28 "../lib/Init.vala"
	_tmp2_ = display_manager;
#line 28 "../lib/Init.vala"
	_tmp3_ = gdk_display_manager_list_displays (_tmp2_);
#line 85 "Init.c"
	{
		GSList* display_collection = NULL;
		GSList* display_it = NULL;
#line 28 "../lib/Init.vala"
		display_collection = _tmp3_;
#line 28 "../lib/Init.vala"
		for (display_it = display_collection; display_it != NULL; display_it = display_it->next) {
#line 93 "Init.c"
			GdkDisplay* display = NULL;
#line 28 "../lib/Init.vala"
			display = (GdkDisplay*) display_it->data;
#line 97 "Init.c"
			{
				GdkDisplay* _tmp4_;
#line 29 "../lib/Init.vala"
				_tmp4_ = display;
#line 29 "../lib/Init.vala"
				granite_register_display (_tmp4_);
#line 104 "Init.c"
			}
		}
#line 28 "../lib/Init.vala"
		(display_collection == NULL) ? NULL : (display_collection = (g_slist_free (display_collection), NULL));
#line 109 "Init.c"
	}
#line 32 "../lib/Init.vala"
	bindtextdomain (GRANITE_GETTEXT_PACKAGE, GRANITE_LOCALEDIR);
#line 33 "../lib/Init.vala"
	bind_textdomain_codeset (GRANITE_GETTEXT_PACKAGE, "UTF-8");
#line 34 "../lib/Init.vala"
	granite_initialized = TRUE;
#line 117 "Init.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 59 "../lib/Init.vala"
	return self ? g_object_ref (self) : NULL;
#line 125 "Init.c"
}

 G_GNUC_INTERNAL void
granite_register_display (GdkDisplay* display)
{
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp3_;
	GtkCssProvider* _tmp17_;
	GtkCssProvider* _tmp18_;
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp20_;
	GtkIconTheme* _tmp21_;
#line 37 "../lib/Init.vala"
	g_return_if_fail (display != NULL);
#line 38 "../lib/Init.vala"
	_tmp0_ = granite_base_provider;
#line 38 "../lib/Init.vala"
	if (_tmp0_ == NULL) {
#line 144 "Init.c"
		GtkCssProvider* _tmp1_;
		GtkCssProvider* _tmp2_;
#line 39 "../lib/Init.vala"
		_tmp1_ = gtk_css_provider_new ();
#line 39 "../lib/Init.vala"
		_g_object_unref0 (granite_base_provider);
#line 39 "../lib/Init.vala"
		granite_base_provider = _tmp1_;
#line 40 "../lib/Init.vala"
		_tmp2_ = granite_base_provider;
#line 40 "../lib/Init.vala"
		gtk_css_provider_load_from_resource (_tmp2_, "/io/elementary/granite/Granite.css");
#line 157 "Init.c"
	}
#line 43 "../lib/Init.vala"
	_tmp3_ = granite_app_provider;
#line 43 "../lib/Init.vala"
	if (_tmp3_ == NULL) {
#line 163 "Init.c"
		gchar* base_path = NULL;
		GApplication* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
#line 44 "../lib/Init.vala"
		_tmp4_ = g_application_get_default ();
#line 44 "../lib/Init.vala"
		_tmp5_ = g_application_get_resource_base_path (_tmp4_);
#line 44 "../lib/Init.vala"
		_tmp6_ = _tmp5_;
#line 44 "../lib/Init.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 44 "../lib/Init.vala"
		base_path = _tmp7_;
#line 45 "../lib/Init.vala"
		_tmp8_ = base_path;
#line 45 "../lib/Init.vala"
		if (_tmp8_ != NULL) {
#line 184 "Init.c"
			gchar* base_uri = NULL;
			const gchar* _tmp9_;
			gchar* _tmp10_;
			GFile* base_file = NULL;
			const gchar* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			GFile* _tmp14_;
			GFile* _tmp15_;
			GtkCssProvider* _tmp16_;
#line 46 "../lib/Init.vala"
			_tmp9_ = base_path;
#line 46 "../lib/Init.vala"
			_tmp10_ = g_strconcat ("resource://", _tmp9_, NULL);
#line 46 "../lib/Init.vala"
			base_uri = _tmp10_;
#line 47 "../lib/Init.vala"
			_tmp11_ = base_uri;
#line 47 "../lib/Init.vala"
			_tmp12_ = g_file_new_for_uri (_tmp11_);
#line 47 "../lib/Init.vala"
			base_file = _tmp12_;
#line 49 "../lib/Init.vala"
			_tmp13_ = base_file;
#line 49 "../lib/Init.vala"
			_tmp14_ = g_file_get_child (_tmp13_, "Application.css");
#line 49 "../lib/Init.vala"
			_tmp15_ = _tmp14_;
#line 49 "../lib/Init.vala"
			_tmp16_ = granite_init_provider_from_file (_tmp15_);
#line 49 "../lib/Init.vala"
			_g_object_unref0 (granite_app_provider);
#line 49 "../lib/Init.vala"
			granite_app_provider = _tmp16_;
#line 49 "../lib/Init.vala"
			_g_object_unref0 (_tmp15_);
#line 45 "../lib/Init.vala"
			_g_object_unref0 (base_file);
#line 45 "../lib/Init.vala"
			_g_free0 (base_uri);
#line 225 "Init.c"
		}
#line 43 "../lib/Init.vala"
		_g_free0 (base_path);
#line 229 "Init.c"
	}
#line 53 "../lib/Init.vala"
	_tmp17_ = granite_base_provider;
#line 53 "../lib/Init.vala"
	gtk_style_context_add_provider_for_display (display, (GtkStyleProvider*) _tmp17_, (guint) GTK_STYLE_PROVIDER_PRIORITY_THEME);
#line 55 "../lib/Init.vala"
	_tmp18_ = granite_app_provider;
#line 55 "../lib/Init.vala"
	if (_tmp18_ != NULL) {
#line 239 "Init.c"
		GtkCssProvider* _tmp19_;
#line 56 "../lib/Init.vala"
		_tmp19_ = granite_app_provider;
#line 56 "../lib/Init.vala"
		gtk_style_context_add_provider_for_display (display, (GtkStyleProvider*) _tmp19_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 245 "Init.c"
	}
#line 59 "../lib/Init.vala"
	_tmp20_ = gtk_icon_theme_get_for_display (display);
#line 59 "../lib/Init.vala"
	_tmp21_ = _g_object_ref0 (_tmp20_);
#line 59 "../lib/Init.vala"
	icon_theme = _tmp21_;
#line 60 "../lib/Init.vala"
	gtk_icon_theme_add_resource_path (icon_theme, "/io/elementary/granite");
#line 37 "../lib/Init.vala"
	_g_object_unref0 (icon_theme);
#line 257 "Init.c"
}

 G_GNUC_INTERNAL GtkCssProvider*
granite_init_provider_from_file (GFile* file)
{
	GtkCssProvider* result;
#line 63 "../lib/Init.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 64 "../lib/Init.vala"
	if (g_file_query_exists (file, NULL)) {
#line 268 "Init.c"
		GtkCssProvider* provider = NULL;
		GtkCssProvider* _tmp0_;
		GtkCssProvider* _tmp1_;
#line 65 "../lib/Init.vala"
		_tmp0_ = gtk_css_provider_new ();
#line 65 "../lib/Init.vala"
		provider = _tmp0_;
#line 66 "../lib/Init.vala"
		_tmp1_ = provider;
#line 66 "../lib/Init.vala"
		gtk_css_provider_load_from_file (_tmp1_, file);
#line 68 "../lib/Init.vala"
		result = provider;
#line 68 "../lib/Init.vala"
		return result;
#line 284 "Init.c"
	}
#line 71 "../lib/Init.vala"
	result = NULL;
#line 71 "../lib/Init.vala"
	return result;
#line 290 "Init.c"
}

