/* TimePicker.c generated by valac 0.56.17, the Vala compiler
 * generated from TimePicker.vala, do not modify */

/*
 * Copyright 2018–2022 elementary, Inc. (https://elementary.io)
 * Copyright 2011–2013 Maxwell Barvian <maxwell@elementaryos.org>
 * Copyright 2011–2013 Corentin Noël <tintou@noel.tf>
 * SPDX-License-Identifier: LGPL-3.0-or-later
 */

#include "granite-7.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GRANITE_TIME_PICKER_0_PROPERTY,
	GRANITE_TIME_PICKER_FORMAT_12_PROPERTY,
	GRANITE_TIME_PICKER_FORMAT_24_PROPERTY,
	GRANITE_TIME_PICKER_TIME_PROPERTY,
	GRANITE_TIME_PICKER_NUM_PROPERTIES
};
static GParamSpec* granite_time_picker_properties[GRANITE_TIME_PICKER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GRANITE_TIME_PICKER_TIME_CHANGED_SIGNAL,
	GRANITE_TIME_PICKER_NUM_SIGNALS
};
static guint granite_time_picker_signals[GRANITE_TIME_PICKER_NUM_SIGNALS] = {0};

struct _GraniteTimePickerPrivate {
	gchar* _format_12;
	gchar* _format_24;
	GDateTime* _time;
	gboolean changing_time;
	gchar* old_string;
	GtkBox* am_pm_box;
	GtkPopover* popover;
	GtkSpinButton* hours_spinbutton;
	GtkSpinButton* minutes_spinbutton;
	GtkToggleButton* am_togglebutton;
	GtkToggleButton* pm_togglebutton;
};

static gint GraniteTimePicker_private_offset;
static gpointer granite_time_picker_parent_class = NULL;

static void granite_time_picker_update_text (GraniteTimePicker* self,
                                      gboolean no_signal);
static void granite_time_picker_update_am_pm (GraniteTimePicker* self,
                                       gint hours);
static void granite_time_picker_update_time (GraniteTimePicker* self,
                                      gboolean is_hour);
 G_GNUC_INTERNAL gboolean granite_date_time_is_clock_format_12h (void);
static void granite_time_picker_on_icon_press (GraniteTimePicker* self,
                                        GtkEntryIconPosition position);
static void granite_time_picker_is_unfocused (GraniteTimePicker* self);
static void granite_time_picker_parse_time (GraniteTimePicker* self,
                                     const gchar* timestr);
static gint* _int_dup (gint* self);
static gboolean _int_equal (const gint * s1,
                     const gint * s2);
static GObject * granite_time_picker_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _granite_time_picker_on_icon_press_gtk_entry_icon_release (GtkEntry* _sender,
                                                                GtkEntryIconPosition icon_pos,
                                                                gpointer self);
static void _granite_time_picker___lambda27_ (GraniteTimePicker* self);
static void __granite_time_picker___lambda27__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                      gpointer self);
static void _granite_time_picker___lambda28_ (GraniteTimePicker* self);
static void __granite_time_picker___lambda28__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                      gpointer self);
static gboolean _granite_time_picker___lambda29_ (GraniteTimePicker* self);
static gboolean __granite_time_picker___lambda29__gtk_spin_button_output (GtkSpinButton* _sender,
                                                                   gpointer self);
static void _granite_time_picker___lambda30_ (GraniteTimePicker* self);
static void __granite_time_picker___lambda30__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                         gpointer self);
static gboolean _granite_time_picker___lambda31_ (GraniteTimePicker* self,
                                           gdouble dx,
                                           gdouble dy);
static gboolean __granite_time_picker___lambda31__gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                               gdouble dx,
                                                                               gdouble dy,
                                                                               gpointer self);
static void _granite_time_picker_is_unfocused_gtk_entry_activate (GtkEntry* _sender,
                                                           gpointer self);
static void _granite_time_picker___lambda32_ (GraniteTimePicker* self);
static void __granite_time_picker___lambda32__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void _granite_time_picker___lambda33_ (GraniteTimePicker* self);
static void __granite_time_picker___lambda33__gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void granite_time_picker_finalize (GObject * obj);
static GType granite_time_picker_get_type_once (void);
static void _vala_granite_time_picker_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_granite_time_picker_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
granite_time_picker_get_instance_private (GraniteTimePicker* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteTimePicker_private_offset);
}

const gchar*
granite_time_picker_get_format_12 (GraniteTimePicker* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 20 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_format_12;
#line 20 "../lib/Widgets/TimePicker.vala"
	result = _tmp0_;
#line 20 "../lib/Widgets/TimePicker.vala"
	return result;
#line 144 "TimePicker.c"
}

static void
granite_time_picker_set_format_12 (GraniteTimePicker* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 20 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 20 "../lib/Widgets/TimePicker.vala"
	old_value = granite_time_picker_get_format_12 (self);
#line 20 "../lib/Widgets/TimePicker.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 158 "TimePicker.c"
		gchar* _tmp0_;
#line 20 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_strdup (value);
#line 20 "../lib/Widgets/TimePicker.vala"
		_g_free0 (self->priv->_format_12);
#line 20 "../lib/Widgets/TimePicker.vala"
		self->priv->_format_12 = _tmp0_;
#line 20 "../lib/Widgets/TimePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_time_picker_properties[GRANITE_TIME_PICKER_FORMAT_12_PROPERTY]);
#line 168 "TimePicker.c"
	}
}

const gchar*
granite_time_picker_get_format_24 (GraniteTimePicker* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_format_24;
#line 25 "../lib/Widgets/TimePicker.vala"
	result = _tmp0_;
#line 25 "../lib/Widgets/TimePicker.vala"
	return result;
#line 185 "TimePicker.c"
}

static void
granite_time_picker_set_format_24 (GraniteTimePicker* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 25 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 25 "../lib/Widgets/TimePicker.vala"
	old_value = granite_time_picker_get_format_24 (self);
#line 25 "../lib/Widgets/TimePicker.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 199 "TimePicker.c"
		gchar* _tmp0_;
#line 25 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../lib/Widgets/TimePicker.vala"
		_g_free0 (self->priv->_format_24);
#line 25 "../lib/Widgets/TimePicker.vala"
		self->priv->_format_24 = _tmp0_;
#line 25 "../lib/Widgets/TimePicker.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_time_picker_properties[GRANITE_TIME_PICKER_FORMAT_24_PROPERTY]);
#line 209 "TimePicker.c"
	}
}

GDateTime*
granite_time_picker_get_time (GraniteTimePicker* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	GDateTime* _tmp3_;
#line 32 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_time;
#line 33 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_ == NULL) {
#line 225 "TimePicker.c"
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 34 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = g_date_time_new_now_local ();
#line 34 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 34 "../lib/Widgets/TimePicker.vala"
		granite_time_picker_set_time (self, _tmp2_);
#line 34 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (_tmp2_);
#line 236 "TimePicker.c"
	}
#line 37 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = self->priv->_time;
#line 37 "../lib/Widgets/TimePicker.vala"
	result = _tmp3_;
#line 37 "../lib/Widgets/TimePicker.vala"
	return result;
#line 244 "TimePicker.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 41 "../lib/Widgets/TimePicker.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 252 "TimePicker.c"
}

void
granite_time_picker_set_time (GraniteTimePicker* self,
                              GDateTime* value)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
#line 40 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 41 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 41 "../lib/Widgets/TimePicker.vala"
	_g_date_time_unref0 (self->priv->_time);
#line 41 "../lib/Widgets/TimePicker.vala"
	self->priv->_time = _tmp0_;
#line 42 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = TRUE;
#line 44 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->_time;
#line 44 "../lib/Widgets/TimePicker.vala"
	if (g_date_time_get_hour (_tmp1_) >= 12) {
#line 275 "TimePicker.c"
		GtkToggleButton* _tmp2_;
#line 45 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = self->priv->pm_togglebutton;
#line 45 "../lib/Widgets/TimePicker.vala"
		gtk_toggle_button_set_active (_tmp2_, TRUE);
#line 281 "TimePicker.c"
	} else {
		GtkToggleButton* _tmp3_;
#line 47 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->am_togglebutton;
#line 47 "../lib/Widgets/TimePicker.vala"
		gtk_toggle_button_set_active (_tmp3_, TRUE);
#line 288 "TimePicker.c"
	}
#line 50 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_update_text (self, TRUE);
#line 51 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = FALSE;
#line 40 "../lib/Widgets/TimePicker.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_time_picker_properties[GRANITE_TIME_PICKER_TIME_PROPERTY]);
#line 296 "TimePicker.c"
}

/**
     * Creates a new TimePicker.
     *
     * @param format_12 The desired custom 12h format. For example "%l:%M %p".
     * @param format_24 The desired custom 24h format. For example "%H:%M".
     */
GraniteTimePicker*
granite_time_picker_construct_with_format (GType object_type,
                                           const gchar* format_12,
                                           const gchar* format_24)
{
	GraniteTimePicker * self = NULL;
#line 71 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (format_12 != NULL, NULL);
#line 71 "../lib/Widgets/TimePicker.vala"
	g_return_val_if_fail (format_24 != NULL, NULL);
#line 72 "../lib/Widgets/TimePicker.vala"
	self = (GraniteTimePicker*) g_object_new (object_type, "format-12", format_12, "format-24", format_24, NULL);
#line 71 "../lib/Widgets/TimePicker.vala"
	return self;
#line 319 "TimePicker.c"
}

GraniteTimePicker*
granite_time_picker_new_with_format (const gchar* format_12,
                                     const gchar* format_24)
{
#line 71 "../lib/Widgets/TimePicker.vala"
	return granite_time_picker_construct_with_format (GRANITE_TYPE_TIME_PICKER, format_12, format_24);
#line 328 "TimePicker.c"
}

static void
granite_time_picker_update_am_pm (GraniteTimePicker* self,
                                  gint hours)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
#line 194 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 195 "../lib/Widgets/TimePicker.vala"
	if (self->priv->changing_time) {
#line 196 "../lib/Widgets/TimePicker.vala"
		return;
#line 344 "TimePicker.c"
	}
#line 199 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_time;
#line 199 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_date_time_add_hours (_tmp0_, hours);
#line 199 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = _tmp1_;
#line 199 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_set_time (self, _tmp2_);
#line 199 "../lib/Widgets/TimePicker.vala"
	_g_date_time_unref0 (_tmp2_);
#line 200 "../lib/Widgets/TimePicker.vala"
	g_signal_emit (self, granite_time_picker_signals[GRANITE_TIME_PICKER_TIME_CHANGED_SIGNAL], 0);
#line 202 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_update_text (self, TRUE);
#line 360 "TimePicker.c"
}

static void
granite_time_picker_update_time (GraniteTimePicker* self,
                                 gboolean is_hour)
{
#line 205 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 206 "../lib/Widgets/TimePicker.vala"
	if (self->priv->changing_time) {
#line 207 "../lib/Widgets/TimePicker.vala"
		return;
#line 373 "TimePicker.c"
	}
#line 210 "../lib/Widgets/TimePicker.vala"
	if (is_hour) {
#line 377 "TimePicker.c"
		gint new_hour = 0;
		GtkSpinButton* _tmp0_;
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 211 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = self->priv->hours_spinbutton;
#line 211 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = granite_time_picker_get_time (self);
#line 211 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 211 "../lib/Widgets/TimePicker.vala"
		new_hour = gtk_spin_button_get_value_as_int (_tmp0_) - g_date_time_get_hour (_tmp2_);
#line 213 "../lib/Widgets/TimePicker.vala"
		if (granite_date_time_is_clock_format_12h ()) {
#line 392 "TimePicker.c"
			gboolean _tmp3_ = FALSE;
			GtkSpinButton* _tmp4_;
#line 214 "../lib/Widgets/TimePicker.vala"
			_tmp4_ = self->priv->hours_spinbutton;
#line 214 "../lib/Widgets/TimePicker.vala"
			if (gtk_spin_button_get_value_as_int (_tmp4_) == 12) {
#line 399 "TimePicker.c"
				GtkToggleButton* _tmp5_;
				gboolean _tmp6_;
				gboolean _tmp7_;
#line 214 "../lib/Widgets/TimePicker.vala"
				_tmp5_ = self->priv->am_togglebutton;
#line 214 "../lib/Widgets/TimePicker.vala"
				_tmp6_ = gtk_toggle_button_get_active (_tmp5_);
#line 214 "../lib/Widgets/TimePicker.vala"
				_tmp7_ = _tmp6_;
#line 214 "../lib/Widgets/TimePicker.vala"
				_tmp3_ = _tmp7_;
#line 411 "TimePicker.c"
			} else {
#line 214 "../lib/Widgets/TimePicker.vala"
				_tmp3_ = FALSE;
#line 415 "TimePicker.c"
			}
#line 214 "../lib/Widgets/TimePicker.vala"
			_tmp3_ = TRUE;
#line 214 "../lib/Widgets/TimePicker.vala"
			if (_tmp3_) {
#line 421 "TimePicker.c"
				GDateTime* _tmp8_;
				GDateTime* _tmp9_;
				GDateTime* _tmp10_;
#line 215 "../lib/Widgets/TimePicker.vala"
				_tmp8_ = self->priv->_time;
#line 215 "../lib/Widgets/TimePicker.vala"
				_tmp9_ = self->priv->_time;
#line 215 "../lib/Widgets/TimePicker.vala"
				_tmp10_ = g_date_time_add_hours (_tmp8_, -g_date_time_get_hour (_tmp9_));
#line 215 "../lib/Widgets/TimePicker.vala"
				_g_date_time_unref0 (self->priv->_time);
#line 215 "../lib/Widgets/TimePicker.vala"
				self->priv->_time = _tmp10_;
#line 435 "TimePicker.c"
			} else {
				gboolean _tmp11_ = FALSE;
				GtkSpinButton* _tmp12_;
#line 216 "../lib/Widgets/TimePicker.vala"
				_tmp12_ = self->priv->hours_spinbutton;
#line 216 "../lib/Widgets/TimePicker.vala"
				if (gtk_spin_button_get_value_as_int (_tmp12_) < 12) {
#line 443 "TimePicker.c"
					GtkToggleButton* _tmp13_;
					gboolean _tmp14_;
					gboolean _tmp15_;
#line 216 "../lib/Widgets/TimePicker.vala"
					_tmp13_ = self->priv->am_togglebutton;
#line 216 "../lib/Widgets/TimePicker.vala"
					_tmp14_ = gtk_toggle_button_get_active (_tmp13_);
#line 216 "../lib/Widgets/TimePicker.vala"
					_tmp15_ = _tmp14_;
#line 216 "../lib/Widgets/TimePicker.vala"
					_tmp11_ = _tmp15_;
#line 455 "TimePicker.c"
				} else {
#line 216 "../lib/Widgets/TimePicker.vala"
					_tmp11_ = FALSE;
#line 459 "TimePicker.c"
				}
#line 216 "../lib/Widgets/TimePicker.vala"
				_tmp11_ = TRUE;
#line 216 "../lib/Widgets/TimePicker.vala"
				if (_tmp11_) {
#line 465 "TimePicker.c"
					GDateTime* _tmp16_;
					GDateTime* _tmp17_;
#line 217 "../lib/Widgets/TimePicker.vala"
					_tmp16_ = self->priv->_time;
#line 217 "../lib/Widgets/TimePicker.vala"
					_tmp17_ = g_date_time_add_hours (_tmp16_, new_hour);
#line 217 "../lib/Widgets/TimePicker.vala"
					_g_date_time_unref0 (self->priv->_time);
#line 217 "../lib/Widgets/TimePicker.vala"
					self->priv->_time = _tmp17_;
#line 476 "TimePicker.c"
				} else {
					gboolean _tmp18_ = FALSE;
					GtkSpinButton* _tmp19_;
#line 218 "../lib/Widgets/TimePicker.vala"
					_tmp19_ = self->priv->hours_spinbutton;
#line 218 "../lib/Widgets/TimePicker.vala"
					if (gtk_spin_button_get_value_as_int (_tmp19_) == 12) {
#line 484 "TimePicker.c"
						GtkToggleButton* _tmp20_;
						gboolean _tmp21_;
						gboolean _tmp22_;
#line 218 "../lib/Widgets/TimePicker.vala"
						_tmp20_ = self->priv->pm_togglebutton;
#line 218 "../lib/Widgets/TimePicker.vala"
						_tmp21_ = gtk_toggle_button_get_active (_tmp20_);
#line 218 "../lib/Widgets/TimePicker.vala"
						_tmp22_ = _tmp21_;
#line 218 "../lib/Widgets/TimePicker.vala"
						_tmp18_ = _tmp22_;
#line 496 "TimePicker.c"
					} else {
#line 218 "../lib/Widgets/TimePicker.vala"
						_tmp18_ = FALSE;
#line 500 "TimePicker.c"
					}
#line 218 "../lib/Widgets/TimePicker.vala"
					_tmp18_ = TRUE;
#line 218 "../lib/Widgets/TimePicker.vala"
					if (_tmp18_) {
#line 506 "TimePicker.c"
						GDateTime* _tmp23_;
						GDateTime* _tmp24_;
						GDateTime* _tmp25_;
#line 219 "../lib/Widgets/TimePicker.vala"
						_tmp23_ = self->priv->_time;
#line 219 "../lib/Widgets/TimePicker.vala"
						_tmp24_ = self->priv->_time;
#line 219 "../lib/Widgets/TimePicker.vala"
						_tmp25_ = g_date_time_add_hours (_tmp23_, (-g_date_time_get_hour (_tmp24_)) + 12);
#line 219 "../lib/Widgets/TimePicker.vala"
						_g_date_time_unref0 (self->priv->_time);
#line 219 "../lib/Widgets/TimePicker.vala"
						self->priv->_time = _tmp25_;
#line 520 "TimePicker.c"
					} else {
						gboolean _tmp26_ = FALSE;
						GtkSpinButton* _tmp27_;
#line 220 "../lib/Widgets/TimePicker.vala"
						_tmp27_ = self->priv->hours_spinbutton;
#line 220 "../lib/Widgets/TimePicker.vala"
						if (gtk_spin_button_get_value_as_int (_tmp27_) < 12) {
#line 528 "TimePicker.c"
							GtkToggleButton* _tmp28_;
							gboolean _tmp29_;
							gboolean _tmp30_;
#line 220 "../lib/Widgets/TimePicker.vala"
							_tmp28_ = self->priv->pm_togglebutton;
#line 220 "../lib/Widgets/TimePicker.vala"
							_tmp29_ = gtk_toggle_button_get_active (_tmp28_);
#line 220 "../lib/Widgets/TimePicker.vala"
							_tmp30_ = _tmp29_;
#line 220 "../lib/Widgets/TimePicker.vala"
							_tmp26_ = _tmp30_;
#line 540 "TimePicker.c"
						} else {
#line 220 "../lib/Widgets/TimePicker.vala"
							_tmp26_ = FALSE;
#line 544 "TimePicker.c"
						}
#line 220 "../lib/Widgets/TimePicker.vala"
						_tmp26_ = TRUE;
#line 220 "../lib/Widgets/TimePicker.vala"
						if (_tmp26_) {
#line 550 "TimePicker.c"
							GDateTime* _tmp31_;
							GDateTime* _tmp32_;
							GDateTime* _tmp33_;
							GDateTime* _tmp34_;
#line 221 "../lib/Widgets/TimePicker.vala"
							_tmp31_ = self->priv->_time;
#line 221 "../lib/Widgets/TimePicker.vala"
							_tmp32_ = g_date_time_add_hours (_tmp31_, new_hour + 12);
#line 221 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (self->priv->_time);
#line 221 "../lib/Widgets/TimePicker.vala"
							self->priv->_time = _tmp32_;
#line 223 "../lib/Widgets/TimePicker.vala"
							_tmp33_ = granite_time_picker_get_time (self);
#line 223 "../lib/Widgets/TimePicker.vala"
							_tmp34_ = _tmp33_;
#line 223 "../lib/Widgets/TimePicker.vala"
							if (g_date_time_get_hour (_tmp34_) <= 12) {
#line 569 "TimePicker.c"
								GDateTime* _tmp35_;
								GDateTime* _tmp36_;
#line 224 "../lib/Widgets/TimePicker.vala"
								_tmp35_ = self->priv->_time;
#line 224 "../lib/Widgets/TimePicker.vala"
								_tmp36_ = g_date_time_add_hours (_tmp35_, 12);
#line 224 "../lib/Widgets/TimePicker.vala"
								_g_date_time_unref0 (self->priv->_time);
#line 224 "../lib/Widgets/TimePicker.vala"
								self->priv->_time = _tmp36_;
#line 580 "TimePicker.c"
							}
						}
					}
				}
			}
		} else {
			GDateTime* _tmp37_;
			GDateTime* _tmp38_;
#line 228 "../lib/Widgets/TimePicker.vala"
			_tmp37_ = self->priv->_time;
#line 228 "../lib/Widgets/TimePicker.vala"
			_tmp38_ = g_date_time_add_hours (_tmp37_, new_hour);
#line 228 "../lib/Widgets/TimePicker.vala"
			_g_date_time_unref0 (self->priv->_time);
#line 228 "../lib/Widgets/TimePicker.vala"
			self->priv->_time = _tmp38_;
#line 597 "TimePicker.c"
		}
	} else {
		GDateTime* _tmp39_;
		GDateTime* _tmp40_;
		GtkSpinButton* _tmp41_;
		GDateTime* _tmp42_;
		GDateTime* _tmp43_;
		GDateTime* _tmp44_;
#line 231 "../lib/Widgets/TimePicker.vala"
		_tmp39_ = granite_time_picker_get_time (self);
#line 231 "../lib/Widgets/TimePicker.vala"
		_tmp40_ = _tmp39_;
#line 231 "../lib/Widgets/TimePicker.vala"
		_tmp41_ = self->priv->minutes_spinbutton;
#line 231 "../lib/Widgets/TimePicker.vala"
		_tmp42_ = granite_time_picker_get_time (self);
#line 231 "../lib/Widgets/TimePicker.vala"
		_tmp43_ = _tmp42_;
#line 231 "../lib/Widgets/TimePicker.vala"
		_tmp44_ = g_date_time_add_minutes (_tmp40_, gtk_spin_button_get_value_as_int (_tmp41_) - g_date_time_get_minute (_tmp43_));
#line 231 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (self->priv->_time);
#line 231 "../lib/Widgets/TimePicker.vala"
		self->priv->_time = _tmp44_;
#line 622 "TimePicker.c"
	}
#line 234 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_update_text (self, FALSE);
#line 626 "TimePicker.c"
}

static void
granite_time_picker_on_icon_press (GraniteTimePicker* self,
                                   GtkEntryIconPosition position)
{
	gboolean _tmp0_ = FALSE;
	GtkSpinButton* _tmp27_;
	GDateTime* _tmp28_;
	GDateTime* _tmp29_;
	GtkPopover* _tmp30_;
#line 237 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 239 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_update_text (self, FALSE);
#line 240 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = TRUE;
#line 242 "../lib/Widgets/TimePicker.vala"
	if (granite_date_time_is_clock_format_12h ()) {
#line 646 "TimePicker.c"
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 242 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = granite_time_picker_get_time (self);
#line 242 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 242 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_date_time_get_hour (_tmp2_) > 12;
#line 655 "TimePicker.c"
	} else {
#line 242 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = FALSE;
#line 659 "TimePicker.c"
	}
#line 242 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 663 "TimePicker.c"
		GtkSpinButton* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
#line 243 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->hours_spinbutton;
#line 243 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = granite_time_picker_get_time (self);
#line 243 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _tmp4_;
#line 243 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_value (_tmp3_, (gdouble) (g_date_time_get_hour (_tmp5_) - 12));
#line 675 "TimePicker.c"
	} else {
		GtkSpinButton* _tmp6_;
		GDateTime* _tmp7_;
		GDateTime* _tmp8_;
#line 245 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = self->priv->hours_spinbutton;
#line 245 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = granite_time_picker_get_time (self);
#line 245 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = _tmp7_;
#line 245 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_value (_tmp6_, (gdouble) g_date_time_get_hour (_tmp8_));
#line 688 "TimePicker.c"
	}
#line 248 "../lib/Widgets/TimePicker.vala"
	if (granite_date_time_is_clock_format_12h ()) {
#line 692 "TimePicker.c"
		GtkBox* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
		GtkSpinButton* _tmp21_;
#line 249 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = self->priv->am_pm_box;
#line 249 "../lib/Widgets/TimePicker.vala"
		gtk_widget_show ((GtkWidget*) _tmp9_);
#line 251 "../lib/Widgets/TimePicker.vala"
		_tmp10_ = granite_time_picker_get_time (self);
#line 251 "../lib/Widgets/TimePicker.vala"
		_tmp11_ = _tmp10_;
#line 251 "../lib/Widgets/TimePicker.vala"
		if (g_date_time_get_hour (_tmp11_) > 12) {
#line 707 "TimePicker.c"
			GtkSpinButton* _tmp12_;
			GDateTime* _tmp13_;
			GDateTime* _tmp14_;
#line 252 "../lib/Widgets/TimePicker.vala"
			_tmp12_ = self->priv->hours_spinbutton;
#line 252 "../lib/Widgets/TimePicker.vala"
			_tmp13_ = granite_time_picker_get_time (self);
#line 252 "../lib/Widgets/TimePicker.vala"
			_tmp14_ = _tmp13_;
#line 252 "../lib/Widgets/TimePicker.vala"
			gtk_spin_button_set_value (_tmp12_, (gdouble) (g_date_time_get_hour (_tmp14_) - 12));
#line 719 "TimePicker.c"
		} else {
			GDateTime* _tmp15_;
			GDateTime* _tmp16_;
#line 253 "../lib/Widgets/TimePicker.vala"
			_tmp15_ = granite_time_picker_get_time (self);
#line 253 "../lib/Widgets/TimePicker.vala"
			_tmp16_ = _tmp15_;
#line 253 "../lib/Widgets/TimePicker.vala"
			if (g_date_time_get_hour (_tmp16_) == 0) {
#line 729 "TimePicker.c"
				GtkSpinButton* _tmp17_;
#line 254 "../lib/Widgets/TimePicker.vala"
				_tmp17_ = self->priv->hours_spinbutton;
#line 254 "../lib/Widgets/TimePicker.vala"
				gtk_spin_button_set_value (_tmp17_, (gdouble) 12);
#line 735 "TimePicker.c"
			} else {
				GtkSpinButton* _tmp18_;
				GDateTime* _tmp19_;
				GDateTime* _tmp20_;
#line 256 "../lib/Widgets/TimePicker.vala"
				_tmp18_ = self->priv->hours_spinbutton;
#line 256 "../lib/Widgets/TimePicker.vala"
				_tmp19_ = granite_time_picker_get_time (self);
#line 256 "../lib/Widgets/TimePicker.vala"
				_tmp20_ = _tmp19_;
#line 256 "../lib/Widgets/TimePicker.vala"
				gtk_spin_button_set_value (_tmp18_, (gdouble) g_date_time_get_hour (_tmp20_));
#line 748 "TimePicker.c"
			}
		}
#line 260 "../lib/Widgets/TimePicker.vala"
		_tmp21_ = self->priv->hours_spinbutton;
#line 260 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_range (_tmp21_, (gdouble) 1, (gdouble) 12);
#line 755 "TimePicker.c"
	} else {
		GtkBox* _tmp22_;
		GtkSpinButton* _tmp23_;
		GDateTime* _tmp24_;
		GDateTime* _tmp25_;
		GtkSpinButton* _tmp26_;
#line 262 "../lib/Widgets/TimePicker.vala"
		_tmp22_ = self->priv->am_pm_box;
#line 262 "../lib/Widgets/TimePicker.vala"
		gtk_widget_hide ((GtkWidget*) _tmp22_);
#line 263 "../lib/Widgets/TimePicker.vala"
		_tmp23_ = self->priv->hours_spinbutton;
#line 263 "../lib/Widgets/TimePicker.vala"
		_tmp24_ = granite_time_picker_get_time (self);
#line 263 "../lib/Widgets/TimePicker.vala"
		_tmp25_ = _tmp24_;
#line 263 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_value (_tmp23_, (gdouble) g_date_time_get_hour (_tmp25_));
#line 265 "../lib/Widgets/TimePicker.vala"
		_tmp26_ = self->priv->hours_spinbutton;
#line 265 "../lib/Widgets/TimePicker.vala"
		gtk_spin_button_set_range (_tmp26_, (gdouble) 0, (gdouble) 23);
#line 778 "TimePicker.c"
	}
#line 268 "../lib/Widgets/TimePicker.vala"
	_tmp27_ = self->priv->minutes_spinbutton;
#line 268 "../lib/Widgets/TimePicker.vala"
	_tmp28_ = granite_time_picker_get_time (self);
#line 268 "../lib/Widgets/TimePicker.vala"
	_tmp29_ = _tmp28_;
#line 268 "../lib/Widgets/TimePicker.vala"
	gtk_spin_button_set_value (_tmp27_, (gdouble) g_date_time_get_minute (_tmp29_));
#line 269 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = FALSE;
#line 271 "../lib/Widgets/TimePicker.vala"
	_tmp30_ = self->priv->popover;
#line 271 "../lib/Widgets/TimePicker.vala"
	gtk_popover_popup (_tmp30_);
#line 794 "TimePicker.c"
}

static void
granite_time_picker_is_unfocused (GraniteTimePicker* self)
{
	gboolean _tmp0_ = FALSE;
	GtkPopover* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 274 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 275 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = self->priv->popover;
#line 275 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 275 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = _tmp2_;
#line 275 "../lib/Widgets/TimePicker.vala"
	if (!_tmp3_) {
#line 814 "TimePicker.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 275 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = self->priv->old_string;
#line 275 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = gtk_editable_get_text ((GtkEditable*) self);
#line 275 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = _tmp5_;
#line 275 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = g_utf8_collate (_tmp4_, _tmp6_) != 0;
#line 826 "TimePicker.c"
	} else {
#line 275 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = FALSE;
#line 830 "TimePicker.c"
	}
#line 275 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_) {
#line 834 "TimePicker.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 276 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = gtk_editable_get_text ((GtkEditable*) self);
#line 276 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = _tmp7_;
#line 276 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 276 "../lib/Widgets/TimePicker.vala"
		_g_free0 (self->priv->old_string);
#line 276 "../lib/Widgets/TimePicker.vala"
		self->priv->old_string = _tmp9_;
#line 277 "../lib/Widgets/TimePicker.vala"
		_tmp10_ = gtk_editable_get_text ((GtkEditable*) self);
#line 277 "../lib/Widgets/TimePicker.vala"
		_tmp11_ = _tmp10_;
#line 277 "../lib/Widgets/TimePicker.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 277 "../lib/Widgets/TimePicker.vala"
		_tmp13_ = _tmp12_;
#line 277 "../lib/Widgets/TimePicker.vala"
		granite_time_picker_parse_time (self, _tmp13_);
#line 277 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp13_);
#line 864 "TimePicker.c"
	}
}

static gchar*
string_to_utf8 (const gchar* self,
                gint* result_length1)
{
	gint string_length = 0;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _result_ = NULL;
	gchar* _tmp2_;
	gint _result__length1;
	gint __result__size_;
	gint _tmp3_;
	gchar* _tmp4_;
	gint _tmp4__length1;
	gchar* result;
#line 1616 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1617 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1617 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1617 "glib-2.0.vapi"
	string_length = _tmp1_;
#line 1618 "glib-2.0.vapi"
	_tmp2_ = g_new0 (gchar, string_length + 1);
#line 1618 "glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1618 "glib-2.0.vapi"
	_result__length1 = string_length + 1;
#line 1618 "glib-2.0.vapi"
	__result__size_ = _result__length1;
#line 1619 "glib-2.0.vapi"
	_tmp3_ = _result__length1;
#line 1619 "glib-2.0.vapi"
	_result__length1 = _tmp3_ - 1;
#line 1620 "glib-2.0.vapi"
	memcpy (_result_, self, (gsize) string_length);
#line 1621 "glib-2.0.vapi"
	_tmp4_ = _result_;
#line 1621 "glib-2.0.vapi"
	_tmp4__length1 = _result__length1;
#line 1621 "glib-2.0.vapi"
	if (result_length1) {
#line 1621 "glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 913 "TimePicker.c"
	}
#line 1621 "glib-2.0.vapi"
	result = _tmp4_;
#line 1621 "glib-2.0.vapi"
	return result;
#line 919 "TimePicker.c"
}

static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 297 "../lib/Widgets/TimePicker.vala"
	dup = g_new0 (gint, 1);
#line 297 "../lib/Widgets/TimePicker.vala"
	memcpy (dup, self, sizeof (gint));
#line 297 "../lib/Widgets/TimePicker.vala"
	return dup;
#line 932 "TimePicker.c"
}

static gpointer
__int_dup0 (gpointer self)
{
#line 297 "../lib/Widgets/TimePicker.vala"
	return self ? _int_dup (self) : NULL;
#line 940 "TimePicker.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 959 "TimePicker.c"
}

static gboolean
_int_equal (const gint * s1,
            const gint * s2)
{
#line 325 "../lib/Widgets/TimePicker.vala"
	if (s1 == s2) {
#line 325 "../lib/Widgets/TimePicker.vala"
		return TRUE;
#line 970 "TimePicker.c"
	}
#line 325 "../lib/Widgets/TimePicker.vala"
	if (s1 == NULL) {
#line 325 "../lib/Widgets/TimePicker.vala"
		return FALSE;
#line 976 "TimePicker.c"
	}
#line 325 "../lib/Widgets/TimePicker.vala"
	if (s2 == NULL) {
#line 325 "../lib/Widgets/TimePicker.vala"
		return FALSE;
#line 982 "TimePicker.c"
	}
#line 325 "../lib/Widgets/TimePicker.vala"
	return (*s1) == (*s2);
#line 986 "TimePicker.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 1013 "TimePicker.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 1019 "TimePicker.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1025 "TimePicker.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1029 "TimePicker.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1037 "TimePicker.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1041 "TimePicker.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 1053 "TimePicker.c"
}

static void
granite_time_picker_parse_time (GraniteTimePicker* self,
                                const gchar* timestr)
{
	gchar* current = NULL;
	gchar* _tmp0_;
	gboolean is_hours = FALSE;
	gboolean is_suffix = FALSE;
	gboolean has_suffix = FALSE;
	gint* hour = NULL;
	gint* minute = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_ = 0;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp5__length1;
	gboolean _tmp65_ = FALSE;
	gboolean _tmp66_ = FALSE;
	gint* _tmp71_;
	gboolean _tmp96_ = FALSE;
	gint* _tmp97_;
#line 281 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 281 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (timestr != NULL);
#line 282 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = g_strdup ("");
#line 282 "../lib/Widgets/TimePicker.vala"
	current = _tmp0_;
#line 283 "../lib/Widgets/TimePicker.vala"
	is_hours = TRUE;
#line 284 "../lib/Widgets/TimePicker.vala"
	is_suffix = FALSE;
#line 285 "../lib/Widgets/TimePicker.vala"
	has_suffix = FALSE;
#line 287 "../lib/Widgets/TimePicker.vala"
	hour = NULL;
#line 288 "../lib/Widgets/TimePicker.vala"
	minute = NULL;
#line 289 "../lib/Widgets/TimePicker.vala"
	_tmp1_ = g_utf8_strdown (timestr, (gssize) -1);
#line 289 "../lib/Widgets/TimePicker.vala"
	_tmp2_ = _tmp1_;
#line 289 "../lib/Widgets/TimePicker.vala"
	_tmp4_ = string_to_utf8 (_tmp2_, &_tmp3_);
#line 289 "../lib/Widgets/TimePicker.vala"
	_tmp5_ = _tmp4_;
#line 289 "../lib/Widgets/TimePicker.vala"
	_tmp5__length1 = _tmp3_;
#line 289 "../lib/Widgets/TimePicker.vala"
	_g_free0 (_tmp2_);
#line 1108 "TimePicker.c"
	{
		gchar* c_collection = NULL;
		gint c_collection_length1 = 0;
		gint _c_collection_size_ = 0;
		gint c_it = 0;
#line 289 "../lib/Widgets/TimePicker.vala"
		c_collection = _tmp5_;
#line 289 "../lib/Widgets/TimePicker.vala"
		c_collection_length1 = _tmp5__length1;
#line 289 "../lib/Widgets/TimePicker.vala"
		for (c_it = 0; c_it < c_collection_length1; c_it = c_it + 1) {
#line 1120 "TimePicker.c"
			gchar c = '\0';
#line 289 "../lib/Widgets/TimePicker.vala"
			c = c_collection[c_it];
#line 1124 "TimePicker.c"
			{
#line 290 "../lib/Widgets/TimePicker.vala"
				if (g_ascii_isdigit (c)) {
#line 1128 "TimePicker.c"
					const gchar* _tmp6_;
					gchar* _tmp7_;
#line 291 "../lib/Widgets/TimePicker.vala"
					_tmp6_ = current;
#line 291 "../lib/Widgets/TimePicker.vala"
					_tmp7_ = g_strdup_printf ("%s%c", _tmp6_, (gint) c);
#line 291 "../lib/Widgets/TimePicker.vala"
					_g_free0 (current);
#line 291 "../lib/Widgets/TimePicker.vala"
					current = _tmp7_;
#line 1139 "TimePicker.c"
				} else {
					gboolean _tmp25_ = FALSE;
					gchar* _tmp26_;
					gchar* _tmp27_;
					gboolean _tmp28_;
#line 293 "../lib/Widgets/TimePicker.vala"
					if (!is_suffix) {
#line 1147 "TimePicker.c"
						const gchar* _tmp8_;
						gboolean _tmp17_ = FALSE;
						gchar* _tmp18_;
						gchar* _tmp19_;
						gboolean _tmp20_;
#line 294 "../lib/Widgets/TimePicker.vala"
						_tmp8_ = current;
#line 294 "../lib/Widgets/TimePicker.vala"
						if (g_strcmp0 (_tmp8_, "") != 0) {
#line 295 "../lib/Widgets/TimePicker.vala"
							if (is_hours) {
#line 1159 "TimePicker.c"
								const gchar* _tmp9_;
								gint _tmp10_;
								gint* _tmp11_;
								gchar* _tmp12_;
#line 296 "../lib/Widgets/TimePicker.vala"
								is_hours = FALSE;
#line 297 "../lib/Widgets/TimePicker.vala"
								_tmp9_ = current;
#line 297 "../lib/Widgets/TimePicker.vala"
								_tmp10_ = atoi (_tmp9_);
#line 297 "../lib/Widgets/TimePicker.vala"
								_tmp11_ = __int_dup0 (&_tmp10_);
#line 297 "../lib/Widgets/TimePicker.vala"
								_g_free0 (hour);
#line 297 "../lib/Widgets/TimePicker.vala"
								hour = _tmp11_;
#line 298 "../lib/Widgets/TimePicker.vala"
								_tmp12_ = g_strdup ("");
#line 298 "../lib/Widgets/TimePicker.vala"
								_g_free0 (current);
#line 298 "../lib/Widgets/TimePicker.vala"
								current = _tmp12_;
#line 1182 "TimePicker.c"
							} else {
								const gchar* _tmp13_;
								gint _tmp14_;
								gint* _tmp15_;
								gchar* _tmp16_;
#line 300 "../lib/Widgets/TimePicker.vala"
								_tmp13_ = current;
#line 300 "../lib/Widgets/TimePicker.vala"
								_tmp14_ = atoi (_tmp13_);
#line 300 "../lib/Widgets/TimePicker.vala"
								_tmp15_ = __int_dup0 (&_tmp14_);
#line 300 "../lib/Widgets/TimePicker.vala"
								_g_free0 (minute);
#line 300 "../lib/Widgets/TimePicker.vala"
								minute = _tmp15_;
#line 301 "../lib/Widgets/TimePicker.vala"
								_tmp16_ = g_strdup ("");
#line 301 "../lib/Widgets/TimePicker.vala"
								_g_free0 (current);
#line 301 "../lib/Widgets/TimePicker.vala"
								current = _tmp16_;
#line 1204 "TimePicker.c"
							}
						}
#line 305 "../lib/Widgets/TimePicker.vala"
						_tmp18_ = g_strdup_printf ("%c", c);
#line 305 "../lib/Widgets/TimePicker.vala"
						_tmp19_ = _tmp18_;
#line 305 "../lib/Widgets/TimePicker.vala"
						_tmp20_ = string_contains (_tmp19_, "a");
#line 305 "../lib/Widgets/TimePicker.vala"
						_g_free0 (_tmp19_);
#line 305 "../lib/Widgets/TimePicker.vala"
						if (_tmp20_) {
#line 305 "../lib/Widgets/TimePicker.vala"
							_tmp17_ = TRUE;
#line 1219 "TimePicker.c"
						} else {
							gchar* _tmp21_;
							gchar* _tmp22_;
#line 305 "../lib/Widgets/TimePicker.vala"
							_tmp21_ = g_strdup_printf ("%c", c);
#line 305 "../lib/Widgets/TimePicker.vala"
							_tmp22_ = _tmp21_;
#line 305 "../lib/Widgets/TimePicker.vala"
							_tmp17_ = string_contains (_tmp22_, "p");
#line 305 "../lib/Widgets/TimePicker.vala"
							_g_free0 (_tmp22_);
#line 1231 "TimePicker.c"
						}
#line 305 "../lib/Widgets/TimePicker.vala"
						if (_tmp17_) {
#line 1235 "TimePicker.c"
							const gchar* _tmp23_;
							gchar* _tmp24_;
#line 306 "../lib/Widgets/TimePicker.vala"
							is_suffix = TRUE;
#line 307 "../lib/Widgets/TimePicker.vala"
							_tmp23_ = current;
#line 307 "../lib/Widgets/TimePicker.vala"
							_tmp24_ = g_strdup_printf ("%s%c", _tmp23_, (gint) c);
#line 307 "../lib/Widgets/TimePicker.vala"
							_g_free0 (current);
#line 307 "../lib/Widgets/TimePicker.vala"
							current = _tmp24_;
#line 1248 "TimePicker.c"
						}
					}
#line 311 "../lib/Widgets/TimePicker.vala"
					_tmp26_ = g_strdup_printf ("%c", c);
#line 311 "../lib/Widgets/TimePicker.vala"
					_tmp27_ = _tmp26_;
#line 311 "../lib/Widgets/TimePicker.vala"
					_tmp28_ = string_contains (_tmp27_, "m");
#line 311 "../lib/Widgets/TimePicker.vala"
					_g_free0 (_tmp27_);
#line 311 "../lib/Widgets/TimePicker.vala"
					if (_tmp28_) {
#line 311 "../lib/Widgets/TimePicker.vala"
						_tmp25_ = is_suffix;
#line 1263 "TimePicker.c"
					} else {
#line 311 "../lib/Widgets/TimePicker.vala"
						_tmp25_ = FALSE;
#line 1267 "TimePicker.c"
					}
#line 311 "../lib/Widgets/TimePicker.vala"
					if (_tmp25_) {
#line 1271 "TimePicker.c"
						gint* _tmp29_;
						gboolean _tmp33_ = FALSE;
						const gchar* _tmp34_;
						gboolean _tmp50_ = FALSE;
						const gchar* _tmp51_;
						GDateTime* _tmp58_;
						GDateTime* _tmp59_;
						gint* _tmp60_;
						GDateTime* _tmp61_;
						GDateTime* _tmp62_;
						GDateTime* _tmp63_;
						GDateTime* _tmp64_;
#line 312 "../lib/Widgets/TimePicker.vala"
						_tmp29_ = hour;
#line 312 "../lib/Widgets/TimePicker.vala"
						if (_tmp29_ == NULL) {
#line 313 "../lib/Widgets/TimePicker.vala"
							c_collection = (g_free (c_collection), NULL);
#line 313 "../lib/Widgets/TimePicker.vala"
							_g_free0 (minute);
#line 313 "../lib/Widgets/TimePicker.vala"
							_g_free0 (hour);
#line 313 "../lib/Widgets/TimePicker.vala"
							_g_free0 (current);
#line 313 "../lib/Widgets/TimePicker.vala"
							return;
#line 1298 "TimePicker.c"
						} else {
							gint* _tmp30_;
#line 314 "../lib/Widgets/TimePicker.vala"
							_tmp30_ = minute;
#line 314 "../lib/Widgets/TimePicker.vala"
							if (_tmp30_ == NULL) {
#line 1305 "TimePicker.c"
								gint _tmp31_;
								gint* _tmp32_;
#line 315 "../lib/Widgets/TimePicker.vala"
								_tmp31_ = 0;
#line 315 "../lib/Widgets/TimePicker.vala"
								_tmp32_ = __int_dup0 (&_tmp31_);
#line 315 "../lib/Widgets/TimePicker.vala"
								_g_free0 (minute);
#line 315 "../lib/Widgets/TimePicker.vala"
								minute = _tmp32_;
#line 1316 "TimePicker.c"
							}
						}
#line 319 "../lib/Widgets/TimePicker.vala"
						_tmp34_ = current;
#line 319 "../lib/Widgets/TimePicker.vala"
						if (string_contains (_tmp34_, "a")) {
#line 319 "../lib/Widgets/TimePicker.vala"
							_tmp33_ = TRUE;
#line 1325 "TimePicker.c"
						} else {
							gint* _tmp35_;
#line 319 "../lib/Widgets/TimePicker.vala"
							_tmp35_ = hour;
#line 319 "../lib/Widgets/TimePicker.vala"
							_tmp33_ = (*_tmp35_) >= 12;
#line 1332 "TimePicker.c"
						}
#line 319 "../lib/Widgets/TimePicker.vala"
						if (_tmp33_) {
#line 1336 "TimePicker.c"
							GDateTime* _tmp36_;
							GDateTime* _tmp37_;
							gint* _tmp38_;
							GDateTime* _tmp39_;
							GDateTime* _tmp40_;
							GDateTime* _tmp41_;
							GDateTime* _tmp42_;
#line 320 "../lib/Widgets/TimePicker.vala"
							_tmp36_ = granite_time_picker_get_time (self);
#line 320 "../lib/Widgets/TimePicker.vala"
							_tmp37_ = _tmp36_;
#line 320 "../lib/Widgets/TimePicker.vala"
							_tmp38_ = hour;
#line 320 "../lib/Widgets/TimePicker.vala"
							_tmp39_ = granite_time_picker_get_time (self);
#line 320 "../lib/Widgets/TimePicker.vala"
							_tmp40_ = _tmp39_;
#line 320 "../lib/Widgets/TimePicker.vala"
							_tmp41_ = g_date_time_add_hours (_tmp37_, (*_tmp38_) - g_date_time_get_hour (_tmp40_));
#line 320 "../lib/Widgets/TimePicker.vala"
							_tmp42_ = _tmp41_;
#line 320 "../lib/Widgets/TimePicker.vala"
							granite_time_picker_set_time (self, _tmp42_);
#line 320 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (_tmp42_);
#line 1362 "TimePicker.c"
						} else {
							GDateTime* _tmp43_;
							GDateTime* _tmp44_;
							gint* _tmp45_;
							GDateTime* _tmp46_;
							GDateTime* _tmp47_;
							GDateTime* _tmp48_;
							GDateTime* _tmp49_;
#line 322 "../lib/Widgets/TimePicker.vala"
							_tmp43_ = granite_time_picker_get_time (self);
#line 322 "../lib/Widgets/TimePicker.vala"
							_tmp44_ = _tmp43_;
#line 322 "../lib/Widgets/TimePicker.vala"
							_tmp45_ = hour;
#line 322 "../lib/Widgets/TimePicker.vala"
							_tmp46_ = granite_time_picker_get_time (self);
#line 322 "../lib/Widgets/TimePicker.vala"
							_tmp47_ = _tmp46_;
#line 322 "../lib/Widgets/TimePicker.vala"
							_tmp48_ = g_date_time_add_hours (_tmp44_, ((*_tmp45_) + 12) - g_date_time_get_hour (_tmp47_));
#line 322 "../lib/Widgets/TimePicker.vala"
							_tmp49_ = _tmp48_;
#line 322 "../lib/Widgets/TimePicker.vala"
							granite_time_picker_set_time (self, _tmp49_);
#line 322 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (_tmp49_);
#line 1389 "TimePicker.c"
						}
#line 325 "../lib/Widgets/TimePicker.vala"
						_tmp51_ = current;
#line 325 "../lib/Widgets/TimePicker.vala"
						if (string_contains (_tmp51_, "a")) {
#line 1395 "TimePicker.c"
							gint* _tmp52_;
							gint _tmp53_;
#line 325 "../lib/Widgets/TimePicker.vala"
							_tmp52_ = hour;
#line 325 "../lib/Widgets/TimePicker.vala"
							_tmp53_ = 12;
#line 325 "../lib/Widgets/TimePicker.vala"
							_tmp50_ = _int_equal (_tmp52_, &_tmp53_) == TRUE;
#line 1404 "TimePicker.c"
						} else {
#line 325 "../lib/Widgets/TimePicker.vala"
							_tmp50_ = FALSE;
#line 1408 "TimePicker.c"
						}
#line 325 "../lib/Widgets/TimePicker.vala"
						if (_tmp50_) {
#line 1412 "TimePicker.c"
							GDateTime* _tmp54_;
							GDateTime* _tmp55_;
							GDateTime* _tmp56_;
							GDateTime* _tmp57_;
#line 326 "../lib/Widgets/TimePicker.vala"
							_tmp54_ = granite_time_picker_get_time (self);
#line 326 "../lib/Widgets/TimePicker.vala"
							_tmp55_ = _tmp54_;
#line 326 "../lib/Widgets/TimePicker.vala"
							_tmp56_ = g_date_time_add_hours (_tmp55_, -12);
#line 326 "../lib/Widgets/TimePicker.vala"
							_tmp57_ = _tmp56_;
#line 326 "../lib/Widgets/TimePicker.vala"
							granite_time_picker_set_time (self, _tmp57_);
#line 326 "../lib/Widgets/TimePicker.vala"
							_g_date_time_unref0 (_tmp57_);
#line 1429 "TimePicker.c"
						}
#line 329 "../lib/Widgets/TimePicker.vala"
						_tmp58_ = granite_time_picker_get_time (self);
#line 329 "../lib/Widgets/TimePicker.vala"
						_tmp59_ = _tmp58_;
#line 329 "../lib/Widgets/TimePicker.vala"
						_tmp60_ = minute;
#line 329 "../lib/Widgets/TimePicker.vala"
						_tmp61_ = granite_time_picker_get_time (self);
#line 329 "../lib/Widgets/TimePicker.vala"
						_tmp62_ = _tmp61_;
#line 329 "../lib/Widgets/TimePicker.vala"
						_tmp63_ = g_date_time_add_minutes (_tmp59_, (*_tmp60_) - g_date_time_get_minute (_tmp62_));
#line 329 "../lib/Widgets/TimePicker.vala"
						_tmp64_ = _tmp63_;
#line 329 "../lib/Widgets/TimePicker.vala"
						granite_time_picker_set_time (self, _tmp64_);
#line 329 "../lib/Widgets/TimePicker.vala"
						_g_date_time_unref0 (_tmp64_);
#line 330 "../lib/Widgets/TimePicker.vala"
						has_suffix = TRUE;
#line 1451 "TimePicker.c"
					}
				}
			}
		}
#line 289 "../lib/Widgets/TimePicker.vala"
		c_collection = (g_free (c_collection), NULL);
#line 1458 "TimePicker.c"
	}
#line 335 "../lib/Widgets/TimePicker.vala"
	if (is_hours == FALSE) {
#line 335 "../lib/Widgets/TimePicker.vala"
		_tmp66_ = is_suffix == FALSE;
#line 1464 "TimePicker.c"
	} else {
#line 335 "../lib/Widgets/TimePicker.vala"
		_tmp66_ = FALSE;
#line 1468 "TimePicker.c"
	}
#line 335 "../lib/Widgets/TimePicker.vala"
	if (_tmp66_) {
#line 1472 "TimePicker.c"
		const gchar* _tmp67_;
#line 335 "../lib/Widgets/TimePicker.vala"
		_tmp67_ = current;
#line 335 "../lib/Widgets/TimePicker.vala"
		_tmp65_ = g_strcmp0 (_tmp67_, "") != 0;
#line 1478 "TimePicker.c"
	} else {
#line 335 "../lib/Widgets/TimePicker.vala"
		_tmp65_ = FALSE;
#line 1482 "TimePicker.c"
	}
#line 335 "../lib/Widgets/TimePicker.vala"
	if (_tmp65_) {
#line 1486 "TimePicker.c"
		const gchar* _tmp68_;
		gint _tmp69_;
		gint* _tmp70_;
#line 336 "../lib/Widgets/TimePicker.vala"
		_tmp68_ = current;
#line 336 "../lib/Widgets/TimePicker.vala"
		_tmp69_ = atoi (_tmp68_);
#line 336 "../lib/Widgets/TimePicker.vala"
		_tmp70_ = __int_dup0 (&_tmp69_);
#line 336 "../lib/Widgets/TimePicker.vala"
		_g_free0 (minute);
#line 336 "../lib/Widgets/TimePicker.vala"
		minute = _tmp70_;
#line 1500 "TimePicker.c"
	}
#line 339 "../lib/Widgets/TimePicker.vala"
	_tmp71_ = hour;
#line 339 "../lib/Widgets/TimePicker.vala"
	if (_tmp71_ == NULL) {
#line 1506 "TimePicker.c"
		const gchar* _tmp72_;
		gint _tmp73_;
		gint _tmp74_;
#line 340 "../lib/Widgets/TimePicker.vala"
		_tmp72_ = current;
#line 340 "../lib/Widgets/TimePicker.vala"
		_tmp73_ = strlen (_tmp72_);
#line 340 "../lib/Widgets/TimePicker.vala"
		_tmp74_ = _tmp73_;
#line 340 "../lib/Widgets/TimePicker.vala"
		if (_tmp74_ < 3) {
#line 1518 "TimePicker.c"
			const gchar* _tmp75_;
			gint _tmp76_;
			gint* _tmp77_;
			gint _tmp78_;
			gint* _tmp79_;
#line 341 "../lib/Widgets/TimePicker.vala"
			_tmp75_ = current;
#line 341 "../lib/Widgets/TimePicker.vala"
			_tmp76_ = atoi (_tmp75_);
#line 341 "../lib/Widgets/TimePicker.vala"
			_tmp77_ = __int_dup0 (&_tmp76_);
#line 341 "../lib/Widgets/TimePicker.vala"
			_g_free0 (hour);
#line 341 "../lib/Widgets/TimePicker.vala"
			hour = _tmp77_;
#line 342 "../lib/Widgets/TimePicker.vala"
			_tmp78_ = 0;
#line 342 "../lib/Widgets/TimePicker.vala"
			_tmp79_ = __int_dup0 (&_tmp78_);
#line 342 "../lib/Widgets/TimePicker.vala"
			_g_free0 (minute);
#line 342 "../lib/Widgets/TimePicker.vala"
			minute = _tmp79_;
#line 1542 "TimePicker.c"
		} else {
			const gchar* _tmp80_;
			gint _tmp81_;
			gint _tmp82_;
#line 343 "../lib/Widgets/TimePicker.vala"
			_tmp80_ = current;
#line 343 "../lib/Widgets/TimePicker.vala"
			_tmp81_ = strlen (_tmp80_);
#line 343 "../lib/Widgets/TimePicker.vala"
			_tmp82_ = _tmp81_;
#line 343 "../lib/Widgets/TimePicker.vala"
			if (_tmp82_ == 4) {
#line 1555 "TimePicker.c"
				const gchar* _tmp83_;
				gchar* _tmp84_;
				gchar* _tmp85_;
				gint _tmp86_;
				gint* _tmp87_;
				const gchar* _tmp88_;
				gchar* _tmp89_;
				gchar* _tmp90_;
				gint _tmp91_;
				gint* _tmp92_;
				gboolean _tmp93_ = FALSE;
				gint* _tmp94_;
#line 344 "../lib/Widgets/TimePicker.vala"
				_tmp83_ = current;
#line 344 "../lib/Widgets/TimePicker.vala"
				_tmp84_ = string_slice (_tmp83_, (glong) 0, (glong) 2);
#line 344 "../lib/Widgets/TimePicker.vala"
				_tmp85_ = _tmp84_;
#line 344 "../lib/Widgets/TimePicker.vala"
				_tmp86_ = atoi (_tmp85_);
#line 344 "../lib/Widgets/TimePicker.vala"
				_tmp87_ = __int_dup0 (&_tmp86_);
#line 344 "../lib/Widgets/TimePicker.vala"
				_g_free0 (hour);
#line 344 "../lib/Widgets/TimePicker.vala"
				hour = _tmp87_;
#line 344 "../lib/Widgets/TimePicker.vala"
				_g_free0 (_tmp85_);
#line 345 "../lib/Widgets/TimePicker.vala"
				_tmp88_ = current;
#line 345 "../lib/Widgets/TimePicker.vala"
				_tmp89_ = string_slice (_tmp88_, (glong) 2, (glong) 4);
#line 345 "../lib/Widgets/TimePicker.vala"
				_tmp90_ = _tmp89_;
#line 345 "../lib/Widgets/TimePicker.vala"
				_tmp91_ = atoi (_tmp90_);
#line 345 "../lib/Widgets/TimePicker.vala"
				_tmp92_ = __int_dup0 (&_tmp91_);
#line 345 "../lib/Widgets/TimePicker.vala"
				_g_free0 (minute);
#line 345 "../lib/Widgets/TimePicker.vala"
				minute = _tmp92_;
#line 345 "../lib/Widgets/TimePicker.vala"
				_g_free0 (_tmp90_);
#line 346 "../lib/Widgets/TimePicker.vala"
				_tmp94_ = hour;
#line 346 "../lib/Widgets/TimePicker.vala"
				if ((*_tmp94_) > 23) {
#line 346 "../lib/Widgets/TimePicker.vala"
					_tmp93_ = TRUE;
#line 1606 "TimePicker.c"
				} else {
					gint* _tmp95_;
#line 346 "../lib/Widgets/TimePicker.vala"
					_tmp95_ = minute;
#line 346 "../lib/Widgets/TimePicker.vala"
					_tmp93_ = (*_tmp95_) > 59;
#line 1613 "TimePicker.c"
				}
#line 346 "../lib/Widgets/TimePicker.vala"
				if (_tmp93_) {
#line 347 "../lib/Widgets/TimePicker.vala"
					_g_free0 (hour);
#line 347 "../lib/Widgets/TimePicker.vala"
					hour = NULL;
#line 348 "../lib/Widgets/TimePicker.vala"
					_g_free0 (minute);
#line 348 "../lib/Widgets/TimePicker.vala"
					minute = NULL;
#line 1625 "TimePicker.c"
				}
			}
		}
	}
#line 353 "../lib/Widgets/TimePicker.vala"
	_tmp97_ = hour;
#line 353 "../lib/Widgets/TimePicker.vala"
	if (_tmp97_ == NULL) {
#line 353 "../lib/Widgets/TimePicker.vala"
		_tmp96_ = TRUE;
#line 1636 "TimePicker.c"
	} else {
		gint* _tmp98_;
#line 353 "../lib/Widgets/TimePicker.vala"
		_tmp98_ = minute;
#line 353 "../lib/Widgets/TimePicker.vala"
		_tmp96_ = _tmp98_ == NULL;
#line 1643 "TimePicker.c"
	}
#line 353 "../lib/Widgets/TimePicker.vala"
	if (_tmp96_) {
#line 354 "../lib/Widgets/TimePicker.vala"
		granite_time_picker_update_text (self, FALSE);
#line 355 "../lib/Widgets/TimePicker.vala"
		_g_free0 (minute);
#line 355 "../lib/Widgets/TimePicker.vala"
		_g_free0 (hour);
#line 355 "../lib/Widgets/TimePicker.vala"
		_g_free0 (current);
#line 355 "../lib/Widgets/TimePicker.vala"
		return;
#line 1657 "TimePicker.c"
	}
#line 358 "../lib/Widgets/TimePicker.vala"
	if (has_suffix == FALSE) {
#line 1661 "TimePicker.c"
		GDateTime* _tmp99_;
		GDateTime* _tmp100_;
		gint* _tmp101_;
		GDateTime* _tmp102_;
		GDateTime* _tmp103_;
		GDateTime* _tmp104_;
		GDateTime* _tmp105_;
		GDateTime* _tmp106_;
		GDateTime* _tmp107_;
		gint* _tmp108_;
		GDateTime* _tmp109_;
		GDateTime* _tmp110_;
		GDateTime* _tmp111_;
		GDateTime* _tmp112_;
#line 359 "../lib/Widgets/TimePicker.vala"
		_tmp99_ = granite_time_picker_get_time (self);
#line 359 "../lib/Widgets/TimePicker.vala"
		_tmp100_ = _tmp99_;
#line 359 "../lib/Widgets/TimePicker.vala"
		_tmp101_ = hour;
#line 359 "../lib/Widgets/TimePicker.vala"
		_tmp102_ = granite_time_picker_get_time (self);
#line 359 "../lib/Widgets/TimePicker.vala"
		_tmp103_ = _tmp102_;
#line 359 "../lib/Widgets/TimePicker.vala"
		_tmp104_ = g_date_time_add_hours (_tmp100_, (*_tmp101_) - g_date_time_get_hour (_tmp103_));
#line 359 "../lib/Widgets/TimePicker.vala"
		_tmp105_ = _tmp104_;
#line 359 "../lib/Widgets/TimePicker.vala"
		granite_time_picker_set_time (self, _tmp105_);
#line 359 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (_tmp105_);
#line 360 "../lib/Widgets/TimePicker.vala"
		_tmp106_ = granite_time_picker_get_time (self);
#line 360 "../lib/Widgets/TimePicker.vala"
		_tmp107_ = _tmp106_;
#line 360 "../lib/Widgets/TimePicker.vala"
		_tmp108_ = minute;
#line 360 "../lib/Widgets/TimePicker.vala"
		_tmp109_ = granite_time_picker_get_time (self);
#line 360 "../lib/Widgets/TimePicker.vala"
		_tmp110_ = _tmp109_;
#line 360 "../lib/Widgets/TimePicker.vala"
		_tmp111_ = g_date_time_add_minutes (_tmp107_, (*_tmp108_) - g_date_time_get_minute (_tmp110_));
#line 360 "../lib/Widgets/TimePicker.vala"
		_tmp112_ = _tmp111_;
#line 360 "../lib/Widgets/TimePicker.vala"
		granite_time_picker_set_time (self, _tmp112_);
#line 360 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (_tmp112_);
#line 1712 "TimePicker.c"
	}
#line 363 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_update_text (self, FALSE);
#line 281 "../lib/Widgets/TimePicker.vala"
	_g_free0 (minute);
#line 281 "../lib/Widgets/TimePicker.vala"
	_g_free0 (hour);
#line 281 "../lib/Widgets/TimePicker.vala"
	_g_free0 (current);
#line 1722 "TimePicker.c"
}

static void
granite_time_picker_update_text (GraniteTimePicker* self,
                                 gboolean no_signal)
{
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
#line 366 "../lib/Widgets/TimePicker.vala"
	g_return_if_fail (self != NULL);
#line 367 "../lib/Widgets/TimePicker.vala"
	if (granite_date_time_is_clock_format_12h ()) {
#line 1736 "TimePicker.c"
		GDateTime* _tmp0_;
		GDateTime* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 368 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = granite_time_picker_get_time (self);
#line 368 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = _tmp0_;
#line 368 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = self->priv->_format_12;
#line 368 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = g_date_time_format (_tmp1_, _tmp2_);
#line 368 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = _tmp3_;
#line 368 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) self, _tmp4_);
#line 368 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp4_);
#line 1756 "TimePicker.c"
	} else {
		GDateTime* _tmp5_;
		GDateTime* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 370 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = granite_time_picker_get_time (self);
#line 370 "../lib/Widgets/TimePicker.vala"
		_tmp6_ = _tmp5_;
#line 370 "../lib/Widgets/TimePicker.vala"
		_tmp7_ = self->priv->_format_24;
#line 370 "../lib/Widgets/TimePicker.vala"
		_tmp8_ = g_date_time_format (_tmp6_, _tmp7_);
#line 370 "../lib/Widgets/TimePicker.vala"
		_tmp9_ = _tmp8_;
#line 370 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) self, _tmp9_);
#line 370 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp9_);
#line 1777 "TimePicker.c"
	}
#line 373 "../lib/Widgets/TimePicker.vala"
	_tmp10_ = gtk_editable_get_text ((GtkEditable*) self);
#line 373 "../lib/Widgets/TimePicker.vala"
	_tmp11_ = _tmp10_;
#line 373 "../lib/Widgets/TimePicker.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 373 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->old_string);
#line 373 "../lib/Widgets/TimePicker.vala"
	self->priv->old_string = _tmp12_;
#line 375 "../lib/Widgets/TimePicker.vala"
	if (no_signal == FALSE) {
#line 376 "../lib/Widgets/TimePicker.vala"
		g_signal_emit (self, granite_time_picker_signals[GRANITE_TIME_PICKER_TIME_CHANGED_SIGNAL], 0);
#line 1793 "TimePicker.c"
	}
}

GraniteTimePicker*
granite_time_picker_construct (GType object_type)
{
	GraniteTimePicker * self = NULL;
#line 11 "../lib/Widgets/TimePicker.vala"
	self = (GraniteTimePicker*) g_object_new (object_type, NULL);
#line 11 "../lib/Widgets/TimePicker.vala"
	return self;
#line 1805 "TimePicker.c"
}

GraniteTimePicker*
granite_time_picker_new (void)
{
#line 11 "../lib/Widgets/TimePicker.vala"
	return granite_time_picker_construct (GRANITE_TYPE_TIME_PICKER);
#line 1813 "TimePicker.c"
}

static void
_granite_time_picker_on_icon_press_gtk_entry_icon_release (GtkEntry* _sender,
                                                           GtkEntryIconPosition icon_pos,
                                                           gpointer self)
{
#line 91 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_on_icon_press ((GraniteTimePicker*) self, icon_pos);
#line 1823 "TimePicker.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 99 "../lib/Widgets/TimePicker.vala"
	return self ? g_object_ref (self) : NULL;
#line 1831 "TimePicker.c"
}

static void
_granite_time_picker___lambda27_ (GraniteTimePicker* self)
{
#line 117 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_update_time (self, TRUE);
#line 1839 "TimePicker.c"
}

static void
__granite_time_picker___lambda27__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                 gpointer self)
{
#line 117 "../lib/Widgets/TimePicker.vala"
	_granite_time_picker___lambda27_ ((GraniteTimePicker*) self);
#line 1848 "TimePicker.c"
}

static void
_granite_time_picker___lambda28_ (GraniteTimePicker* self)
{
#line 122 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_update_time (self, FALSE);
#line 1856 "TimePicker.c"
}

static void
__granite_time_picker___lambda28__gtk_spin_button_value_changed (GtkSpinButton* _sender,
                                                                 gpointer self)
{
#line 122 "../lib/Widgets/TimePicker.vala"
	_granite_time_picker___lambda28_ ((GraniteTimePicker*) self);
#line 1865 "TimePicker.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 1896 "TimePicker.c"
}

static gboolean
_granite_time_picker___lambda29_ (GraniteTimePicker* self)
{
	gdouble val = 0.0;
	GtkSpinButton* _tmp0_;
	gboolean result;
#line 126 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->minutes_spinbutton;
#line 126 "../lib/Widgets/TimePicker.vala"
	val = gtk_spin_button_get_value (_tmp0_);
#line 127 "../lib/Widgets/TimePicker.vala"
	if (val < ((gdouble) 10)) {
#line 1911 "TimePicker.c"
		GtkSpinButton* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 128 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = self->priv->minutes_spinbutton;
#line 128 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = double_to_string (val);
#line 128 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = _tmp2_;
#line 128 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = g_strconcat ("0", _tmp3_, NULL);
#line 128 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _tmp4_;
#line 128 "../lib/Widgets/TimePicker.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp1_, _tmp5_);
#line 128 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp5_);
#line 128 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp3_);
#line 129 "../lib/Widgets/TimePicker.vala"
		result = TRUE;
#line 129 "../lib/Widgets/TimePicker.vala"
		return result;
#line 1937 "TimePicker.c"
	}
#line 132 "../lib/Widgets/TimePicker.vala"
	result = FALSE;
#line 132 "../lib/Widgets/TimePicker.vala"
	return result;
#line 1943 "TimePicker.c"
}

static gboolean
__granite_time_picker___lambda29__gtk_spin_button_output (GtkSpinButton* _sender,
                                                          gpointer self)
{
	gboolean result;
	result = _granite_time_picker___lambda29_ ((GraniteTimePicker*) self);
#line 125 "../lib/Widgets/TimePicker.vala"
	return result;
#line 1954 "TimePicker.c"
}

static void
_granite_time_picker___lambda30_ (GraniteTimePicker* self)
{
#line 166 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_is_unfocused (self);
#line 1962 "TimePicker.c"
}

static void
__granite_time_picker___lambda30__gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                                    gpointer self)
{
#line 165 "../lib/Widgets/TimePicker.vala"
	_granite_time_picker___lambda30_ ((GraniteTimePicker*) self);
#line 1971 "TimePicker.c"
}

static gboolean
_granite_time_picker___lambda31_ (GraniteTimePicker* self,
                                  gdouble dx,
                                  gdouble dy)
{
	gdouble _tmp0_ = 0.0;
	gdouble largest = 0.0;
	gboolean result;
#line 170 "../lib/Widgets/TimePicker.vala"
	if (fabs (dx) > fabs (dy)) {
#line 170 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = dx;
#line 1986 "TimePicker.c"
	} else {
#line 170 "../lib/Widgets/TimePicker.vala"
		_tmp0_ = dy;
#line 1990 "TimePicker.c"
	}
#line 170 "../lib/Widgets/TimePicker.vala"
	largest = _tmp0_;
#line 171 "../lib/Widgets/TimePicker.vala"
	if (largest < ((gdouble) 0)) {
#line 1996 "TimePicker.c"
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
#line 172 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = self->priv->_time;
#line 172 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = g_date_time_add_minutes (_tmp1_, 1);
#line 172 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (self->priv->_time);
#line 172 "../lib/Widgets/TimePicker.vala"
		self->priv->_time = _tmp2_;
#line 2007 "TimePicker.c"
	} else {
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
#line 174 "../lib/Widgets/TimePicker.vala"
		_tmp3_ = self->priv->_time;
#line 174 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = g_date_time_add_minutes (_tmp3_, -1);
#line 174 "../lib/Widgets/TimePicker.vala"
		_g_date_time_unref0 (self->priv->_time);
#line 174 "../lib/Widgets/TimePicker.vala"
		self->priv->_time = _tmp4_;
#line 2019 "TimePicker.c"
	}
#line 177 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_update_text (self, FALSE);
#line 178 "../lib/Widgets/TimePicker.vala"
	result = FALSE;
#line 178 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2027 "TimePicker.c"
}

static gboolean
__granite_time_picker___lambda31__gtk_event_controller_scroll_scroll (GtkEventControllerScroll* _sender,
                                                                      gdouble dx,
                                                                      gdouble dy,
                                                                      gpointer self)
{
	gboolean result;
	result = _granite_time_picker___lambda31_ ((GraniteTimePicker*) self, dx, dy);
#line 169 "../lib/Widgets/TimePicker.vala"
	return result;
#line 2040 "TimePicker.c"
}

static void
_granite_time_picker_is_unfocused_gtk_entry_activate (GtkEntry* _sender,
                                                      gpointer self)
{
#line 181 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_is_unfocused ((GraniteTimePicker*) self);
#line 2049 "TimePicker.c"
}

static void
_granite_time_picker___lambda32_ (GraniteTimePicker* self)
{
#line 184 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_update_am_pm (self, -12);
#line 2057 "TimePicker.c"
}

static void
__granite_time_picker___lambda32__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 183 "../lib/Widgets/TimePicker.vala"
	_granite_time_picker___lambda32_ ((GraniteTimePicker*) self);
#line 2066 "TimePicker.c"
}

static void
_granite_time_picker___lambda33_ (GraniteTimePicker* self)
{
#line 188 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_update_am_pm (self, 12);
#line 2074 "TimePicker.c"
}

static void
__granite_time_picker___lambda33__gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 187 "../lib/Widgets/TimePicker.vala"
	_granite_time_picker___lambda33_ ((GraniteTimePicker*) self);
#line 2083 "TimePicker.c"
}

static GObject *
granite_time_picker_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteTimePicker * self;
	const gchar* _tmp0_;
	const gchar* _tmp3_;
	GThemedIcon* _tmp6_;
	GThemedIcon* _tmp7_;
	GThemedIcon* _tmp8_;
	GThemedIcon* _tmp9_;
	GtkToggleButton* _tmp10_ = NULL;
	GtkToggleButton* _tmp11_;
	GtkToggleButton* _tmp12_;
	GtkToggleButton* _tmp13_ = NULL;
	GtkBox* _tmp14_;
	GtkBox* _tmp15_;
	GtkBox* _tmp16_;
	GtkToggleButton* _tmp17_;
	GtkBox* _tmp18_;
	GtkToggleButton* _tmp19_;
	GtkSpinButton* _tmp22_;
	GtkSpinButton* _tmp23_;
	GtkSpinButton* _tmp24_;
	GtkSpinButton* _tmp25_;
	GtkSpinButton* _tmp26_;
	GtkSpinButton* _tmp27_;
	GtkSpinButton* _tmp28_;
	GtkSpinButton* _tmp29_;
	GtkLabel* separation_label = NULL;
	GtkLabel* _tmp30_;
	GtkBox* pop_grid = NULL;
	GtkBox* _tmp31_;
	GtkBox* _tmp32_;
	GtkSpinButton* _tmp33_;
	GtkBox* _tmp34_;
	GtkLabel* _tmp35_;
	GtkBox* _tmp36_;
	GtkSpinButton* _tmp37_;
	GtkBox* _tmp38_;
	GtkBox* _tmp39_;
	GtkBox* _tmp40_;
	GtkWidget* _tmp41_;
	GtkPopover* _tmp42_ = NULL;
	GtkPopover* _tmp43_;
	GtkEventControllerFocus* focus_controller = NULL;
	GtkEventControllerFocus* _tmp44_;
	GtkEventControllerScroll* scroll_controller = NULL;
	GtkEventControllerScroll* _tmp45_;
	GtkEventControllerFocus* _tmp46_;
	GtkEventController* _tmp47_;
	GtkEventControllerScroll* _tmp48_;
	GtkEventController* _tmp49_;
	GtkEventControllerFocus* _tmp50_;
	GtkEventControllerScroll* _tmp51_;
	GtkToggleButton* _tmp52_;
	GtkToggleButton* _tmp53_;
#line 79 "../lib/Widgets/TimePicker.vala"
	parent_class = G_OBJECT_CLASS (granite_time_picker_parent_class);
#line 79 "../lib/Widgets/TimePicker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 79 "../lib/Widgets/TimePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_TYPE_TIME_PICKER, GraniteTimePicker);
#line 80 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = self->priv->_format_12;
#line 80 "../lib/Widgets/TimePicker.vala"
	if (_tmp0_ == NULL) {
#line 2156 "TimePicker.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 81 "../lib/Widgets/TimePicker.vala"
		_tmp1_ = granite_date_time_get_default_time_format (TRUE, FALSE);
#line 81 "../lib/Widgets/TimePicker.vala"
		_tmp2_ = _tmp1_;
#line 81 "../lib/Widgets/TimePicker.vala"
		granite_time_picker_set_format_12 (self, _tmp2_);
#line 81 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp2_);
#line 2167 "TimePicker.c"
	}
#line 84 "../lib/Widgets/TimePicker.vala"
	_tmp3_ = self->priv->_format_24;
#line 84 "../lib/Widgets/TimePicker.vala"
	if (_tmp3_ == NULL) {
#line 2173 "TimePicker.c"
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 85 "../lib/Widgets/TimePicker.vala"
		_tmp4_ = granite_date_time_get_default_time_format (FALSE, FALSE);
#line 85 "../lib/Widgets/TimePicker.vala"
		_tmp5_ = _tmp4_;
#line 85 "../lib/Widgets/TimePicker.vala"
		granite_time_picker_set_format_24 (self, _tmp5_);
#line 85 "../lib/Widgets/TimePicker.vala"
		_g_free0 (_tmp5_);
#line 2184 "TimePicker.c"
	}
#line 88 "../lib/Widgets/TimePicker.vala"
	gtk_entry_set_max_length ((GtkEntry*) self, 8);
#line 89 "../lib/Widgets/TimePicker.vala"
	_tmp6_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("appointment-symbolic");
#line 89 "../lib/Widgets/TimePicker.vala"
	_tmp7_ = _tmp6_;
#line 89 "../lib/Widgets/TimePicker.vala"
	g_object_set ((GtkEntry*) self, "primary-icon-gicon", (GIcon*) _tmp7_, NULL);
#line 89 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp7_);
#line 90 "../lib/Widgets/TimePicker.vala"
	_tmp8_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("pan-down-symbolic");
#line 90 "../lib/Widgets/TimePicker.vala"
	_tmp9_ = _tmp8_;
#line 90 "../lib/Widgets/TimePicker.vala"
	g_object_set ((GtkEntry*) self, "secondary-icon-gicon", (GIcon*) _tmp9_, NULL);
#line 90 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp9_);
#line 91 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkEntry*) self, "icon-release", (GCallback) _granite_time_picker_on_icon_press_gtk_entry_icon_release, self, 0);
#line 94 "../lib/Widgets/TimePicker.vala"
	_tmp10_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("AM"));
#line 94 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp10_, TRUE);
#line 94 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp10_);
#line 94 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_togglebutton);
#line 94 "../lib/Widgets/TimePicker.vala"
	self->priv->am_togglebutton = _tmp10_;
#line 99 "../lib/Widgets/TimePicker.vala"
	_tmp11_ = self->priv->am_togglebutton;
#line 99 "../lib/Widgets/TimePicker.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 99 "../lib/Widgets/TimePicker.vala"
	_tmp13_ = (GtkToggleButton*) gtk_toggle_button_new_with_label (_ ("PM"));
#line 99 "../lib/Widgets/TimePicker.vala"
	gtk_toggle_button_set_group (_tmp13_, _tmp12_);
#line 99 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp12_);
#line 99 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp13_, TRUE);
#line 99 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp13_);
#line 99 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->pm_togglebutton);
#line 99 "../lib/Widgets/TimePicker.vala"
	self->priv->pm_togglebutton = _tmp13_;
#line 104 "../lib/Widgets/TimePicker.vala"
	_tmp14_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 104 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp14_);
#line 104 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_pm_box);
#line 104 "../lib/Widgets/TimePicker.vala"
	self->priv->am_pm_box = _tmp14_;
#line 105 "../lib/Widgets/TimePicker.vala"
	_tmp15_ = self->priv->am_pm_box;
#line 105 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp15_, GRANITE_STYLE_CLASS_LINKED);
#line 106 "../lib/Widgets/TimePicker.vala"
	_tmp16_ = self->priv->am_pm_box;
#line 106 "../lib/Widgets/TimePicker.vala"
	_tmp17_ = self->priv->am_togglebutton;
#line 106 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp16_, (GtkWidget*) _tmp17_);
#line 107 "../lib/Widgets/TimePicker.vala"
	_tmp18_ = self->priv->am_pm_box;
#line 107 "../lib/Widgets/TimePicker.vala"
	_tmp19_ = self->priv->pm_togglebutton;
#line 107 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp18_, (GtkWidget*) _tmp19_);
#line 109 "../lib/Widgets/TimePicker.vala"
	if (granite_date_time_is_clock_format_12h ()) {
#line 2260 "TimePicker.c"
		GtkSpinButton* _tmp20_;
#line 110 "../lib/Widgets/TimePicker.vala"
		_tmp20_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 1, (gdouble) 12, (gdouble) 1);
#line 110 "../lib/Widgets/TimePicker.vala"
		g_object_ref_sink (_tmp20_);
#line 110 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (self->priv->hours_spinbutton);
#line 110 "../lib/Widgets/TimePicker.vala"
		self->priv->hours_spinbutton = _tmp20_;
#line 2270 "TimePicker.c"
	} else {
		GtkSpinButton* _tmp21_;
#line 112 "../lib/Widgets/TimePicker.vala"
		_tmp21_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 23, (gdouble) 1);
#line 112 "../lib/Widgets/TimePicker.vala"
		g_object_ref_sink (_tmp21_);
#line 112 "../lib/Widgets/TimePicker.vala"
		_g_object_unref0 (self->priv->hours_spinbutton);
#line 112 "../lib/Widgets/TimePicker.vala"
		self->priv->hours_spinbutton = _tmp21_;
#line 2281 "TimePicker.c"
	}
#line 115 "../lib/Widgets/TimePicker.vala"
	_tmp22_ = self->priv->hours_spinbutton;
#line 115 "../lib/Widgets/TimePicker.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp22_, GTK_ORIENTATION_VERTICAL);
#line 116 "../lib/Widgets/TimePicker.vala"
	_tmp23_ = self->priv->hours_spinbutton;
#line 116 "../lib/Widgets/TimePicker.vala"
	gtk_spin_button_set_wrap (_tmp23_, TRUE);
#line 117 "../lib/Widgets/TimePicker.vala"
	_tmp24_ = self->priv->hours_spinbutton;
#line 117 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp24_, "value-changed", (GCallback) __granite_time_picker___lambda27__gtk_spin_button_value_changed, self, 0);
#line 119 "../lib/Widgets/TimePicker.vala"
	_tmp25_ = (GtkSpinButton*) gtk_spin_button_new_with_range ((gdouble) 0, (gdouble) 59, (gdouble) 1);
#line 119 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp25_);
#line 119 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->minutes_spinbutton);
#line 119 "../lib/Widgets/TimePicker.vala"
	self->priv->minutes_spinbutton = _tmp25_;
#line 120 "../lib/Widgets/TimePicker.vala"
	_tmp26_ = self->priv->minutes_spinbutton;
#line 120 "../lib/Widgets/TimePicker.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp26_, GTK_ORIENTATION_VERTICAL);
#line 121 "../lib/Widgets/TimePicker.vala"
	_tmp27_ = self->priv->minutes_spinbutton;
#line 121 "../lib/Widgets/TimePicker.vala"
	gtk_spin_button_set_wrap (_tmp27_, TRUE);
#line 122 "../lib/Widgets/TimePicker.vala"
	_tmp28_ = self->priv->minutes_spinbutton;
#line 122 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp28_, "value-changed", (GCallback) __granite_time_picker___lambda28__gtk_spin_button_value_changed, self, 0);
#line 125 "../lib/Widgets/TimePicker.vala"
	_tmp29_ = self->priv->minutes_spinbutton;
#line 125 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp29_, "output", (GCallback) __granite_time_picker___lambda29__gtk_spin_button_output, self, 0);
#line 136 "../lib/Widgets/TimePicker.vala"
	_tmp30_ = (GtkLabel*) gtk_label_new (_ (":"));
#line 136 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp30_);
#line 136 "../lib/Widgets/TimePicker.vala"
	separation_label = _tmp30_;
#line 138 "../lib/Widgets/TimePicker.vala"
	_tmp31_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 138 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp31_);
#line 138 "../lib/Widgets/TimePicker.vala"
	pop_grid = _tmp31_;
#line 139 "../lib/Widgets/TimePicker.vala"
	_tmp32_ = pop_grid;
#line 139 "../lib/Widgets/TimePicker.vala"
	_tmp33_ = self->priv->hours_spinbutton;
#line 139 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp32_, (GtkWidget*) _tmp33_);
#line 140 "../lib/Widgets/TimePicker.vala"
	_tmp34_ = pop_grid;
#line 140 "../lib/Widgets/TimePicker.vala"
	_tmp35_ = separation_label;
#line 140 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp34_, (GtkWidget*) _tmp35_);
#line 141 "../lib/Widgets/TimePicker.vala"
	_tmp36_ = pop_grid;
#line 141 "../lib/Widgets/TimePicker.vala"
	_tmp37_ = self->priv->minutes_spinbutton;
#line 141 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp36_, (GtkWidget*) _tmp37_);
#line 142 "../lib/Widgets/TimePicker.vala"
	_tmp38_ = pop_grid;
#line 142 "../lib/Widgets/TimePicker.vala"
	_tmp39_ = self->priv->am_pm_box;
#line 142 "../lib/Widgets/TimePicker.vala"
	gtk_box_append (_tmp38_, (GtkWidget*) _tmp39_);
#line 144 "../lib/Widgets/TimePicker.vala"
	_tmp40_ = pop_grid;
#line 144 "../lib/Widgets/TimePicker.vala"
	_tmp41_ = _g_object_ref0 ((GtkWidget*) _tmp40_);
#line 144 "../lib/Widgets/TimePicker.vala"
	_tmp42_ = (GtkPopover*) gtk_popover_new ();
#line 144 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp42_, GTK_ALIGN_END);
#line 144 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_autohide (_tmp42_, TRUE);
#line 144 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_child (_tmp42_, _tmp41_);
#line 144 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (_tmp41_);
#line 144 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_has_arrow (_tmp42_, FALSE);
#line 144 "../lib/Widgets/TimePicker.vala"
	gtk_popover_set_position (_tmp42_, GTK_POS_BOTTOM);
#line 144 "../lib/Widgets/TimePicker.vala"
	g_object_ref_sink (_tmp42_);
#line 144 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->popover);
#line 144 "../lib/Widgets/TimePicker.vala"
	self->priv->popover = _tmp42_;
#line 151 "../lib/Widgets/TimePicker.vala"
	_tmp43_ = self->priv->popover;
#line 151 "../lib/Widgets/TimePicker.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp43_, (GtkWidget*) self);
#line 153 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "time-picker");
#line 156 "../lib/Widgets/TimePicker.vala"
	_tmp44_ = (GtkEventControllerFocus*) gtk_event_controller_focus_new ();
#line 156 "../lib/Widgets/TimePicker.vala"
	focus_controller = _tmp44_;
#line 157 "../lib/Widgets/TimePicker.vala"
	_tmp45_ = (GtkEventControllerScroll*) gtk_event_controller_scroll_new (GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES | GTK_EVENT_CONTROLLER_SCROLL_DISCRETE);
#line 157 "../lib/Widgets/TimePicker.vala"
	scroll_controller = _tmp45_;
#line 162 "../lib/Widgets/TimePicker.vala"
	_tmp46_ = focus_controller;
#line 162 "../lib/Widgets/TimePicker.vala"
	_tmp47_ = _g_object_ref0 ((GtkEventController*) _tmp46_);
#line 162 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp47_);
#line 163 "../lib/Widgets/TimePicker.vala"
	_tmp48_ = scroll_controller;
#line 163 "../lib/Widgets/TimePicker.vala"
	_tmp49_ = _g_object_ref0 ((GtkEventController*) _tmp48_);
#line 163 "../lib/Widgets/TimePicker.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp49_);
#line 165 "../lib/Widgets/TimePicker.vala"
	_tmp50_ = focus_controller;
#line 165 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp50_, "leave", (GCallback) __granite_time_picker___lambda30__gtk_event_controller_focus_leave, self, 0);
#line 169 "../lib/Widgets/TimePicker.vala"
	_tmp51_ = scroll_controller;
#line 169 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object (_tmp51_, "scroll", (GCallback) __granite_time_picker___lambda31__gtk_event_controller_scroll_scroll, self, 0);
#line 181 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkEntry*) self, "activate", (GCallback) _granite_time_picker_is_unfocused_gtk_entry_activate, self, 0);
#line 183 "../lib/Widgets/TimePicker.vala"
	_tmp52_ = self->priv->am_togglebutton;
#line 183 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkButton*) _tmp52_, "clicked", (GCallback) __granite_time_picker___lambda32__gtk_button_clicked, self, 0);
#line 187 "../lib/Widgets/TimePicker.vala"
	_tmp53_ = self->priv->pm_togglebutton;
#line 187 "../lib/Widgets/TimePicker.vala"
	g_signal_connect_object ((GtkButton*) _tmp53_, "clicked", (GCallback) __granite_time_picker___lambda33__gtk_button_clicked, self, 0);
#line 191 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_update_text (self, FALSE);
#line 79 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (scroll_controller);
#line 79 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (focus_controller);
#line 79 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (pop_grid);
#line 79 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (separation_label);
#line 79 "../lib/Widgets/TimePicker.vala"
	return obj;
#line 2435 "TimePicker.c"
}

static void
granite_time_picker_class_init (GraniteTimePickerClass * klass,
                                gpointer klass_data)
{
#line 11 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_parent_class = g_type_class_peek_parent (klass);
#line 11 "../lib/Widgets/TimePicker.vala"
	g_type_class_adjust_private_offset (klass, &GraniteTimePicker_private_offset);
#line 11 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_time_picker_get_property;
#line 11 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_time_picker_set_property;
#line 11 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_time_picker_constructor;
#line 11 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_time_picker_finalize;
#line 2454 "TimePicker.c"
	/**
	     * Format used in 12h mode
	     */
#line 11 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_TIME_PICKER_FORMAT_12_PROPERTY, granite_time_picker_properties[GRANITE_TIME_PICKER_FORMAT_12_PROPERTY] = g_param_spec_string ("format-12", "format-12", "format-12", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2460 "TimePicker.c"
	/**
	     * Format used in 24h mode
	     */
#line 11 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_TIME_PICKER_FORMAT_24_PROPERTY, granite_time_picker_properties[GRANITE_TIME_PICKER_FORMAT_24_PROPERTY] = g_param_spec_string ("format-24", "format-24", "format-24", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 2466 "TimePicker.c"
	/**
	     * Current time
	     */
#line 11 "../lib/Widgets/TimePicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_TIME_PICKER_TIME_PROPERTY, granite_time_picker_properties[GRANITE_TIME_PICKER_TIME_PROPERTY] = g_param_spec_boxed ("time", "time", "time", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2472 "TimePicker.c"
	/**
	     * Sent when the time got changed
	     */
#line 11 "../lib/Widgets/TimePicker.vala"
	granite_time_picker_signals[GRANITE_TIME_PICKER_TIME_CHANGED_SIGNAL] = g_signal_new ("time-changed", GRANITE_TYPE_TIME_PICKER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 76 "../lib/Widgets/TimePicker.vala"
	granite_init ();
#line 2480 "TimePicker.c"
}

static void
granite_time_picker_instance_init (GraniteTimePicker * self,
                                   gpointer klass)
{
	gchar* _tmp0_;
#line 11 "../lib/Widgets/TimePicker.vala"
	self->priv = granite_time_picker_get_instance_private (self);
#line 27 "../lib/Widgets/TimePicker.vala"
	self->priv->_time = NULL;
#line 56 "../lib/Widgets/TimePicker.vala"
	self->priv->changing_time = FALSE;
#line 57 "../lib/Widgets/TimePicker.vala"
	_tmp0_ = g_strdup ("");
#line 57 "../lib/Widgets/TimePicker.vala"
	self->priv->old_string = _tmp0_;
#line 2498 "TimePicker.c"
}

static void
granite_time_picker_finalize (GObject * obj)
{
	GraniteTimePicker * self;
#line 11 "../lib/Widgets/TimePicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_TYPE_TIME_PICKER, GraniteTimePicker);
#line 20 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->_format_12);
#line 25 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->_format_24);
#line 27 "../lib/Widgets/TimePicker.vala"
	_g_date_time_unref0 (self->priv->_time);
#line 57 "../lib/Widgets/TimePicker.vala"
	_g_free0 (self->priv->old_string);
#line 58 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_pm_box);
#line 59 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->popover);
#line 60 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->hours_spinbutton);
#line 61 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->minutes_spinbutton);
#line 62 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->am_togglebutton);
#line 63 "../lib/Widgets/TimePicker.vala"
	_g_object_unref0 (self->priv->pm_togglebutton);
#line 11 "../lib/Widgets/TimePicker.vala"
	G_OBJECT_CLASS (granite_time_picker_parent_class)->finalize (obj);
#line 2529 "TimePicker.c"
}

/**
 * This widget allows users to easily pick a time.
 */
static GType
granite_time_picker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GraniteTimePickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_time_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteTimePicker), 0, (GInstanceInitFunc) granite_time_picker_instance_init, NULL };
	GType granite_time_picker_type_id;
	granite_time_picker_type_id = g_type_register_static (gtk_entry_get_type (), "GraniteTimePicker", &g_define_type_info, 0);
	GraniteTimePicker_private_offset = g_type_add_instance_private (granite_time_picker_type_id, sizeof (GraniteTimePickerPrivate));
	return granite_time_picker_type_id;
}

GType
granite_time_picker_get_type (void)
{
	static volatile gsize granite_time_picker_type_id__once = 0;
	if (g_once_init_enter (&granite_time_picker_type_id__once)) {
		GType granite_time_picker_type_id;
		granite_time_picker_type_id = granite_time_picker_get_type_once ();
		g_once_init_leave (&granite_time_picker_type_id__once, granite_time_picker_type_id);
	}
	return granite_time_picker_type_id__once;
}

static void
_vala_granite_time_picker_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	GraniteTimePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_TYPE_TIME_PICKER, GraniteTimePicker);
#line 11 "../lib/Widgets/TimePicker.vala"
	switch (property_id) {
#line 11 "../lib/Widgets/TimePicker.vala"
		case GRANITE_TIME_PICKER_FORMAT_12_PROPERTY:
#line 11 "../lib/Widgets/TimePicker.vala"
		g_value_set_string (value, granite_time_picker_get_format_12 (self));
#line 11 "../lib/Widgets/TimePicker.vala"
		break;
#line 11 "../lib/Widgets/TimePicker.vala"
		case GRANITE_TIME_PICKER_FORMAT_24_PROPERTY:
#line 11 "../lib/Widgets/TimePicker.vala"
		g_value_set_string (value, granite_time_picker_get_format_24 (self));
#line 11 "../lib/Widgets/TimePicker.vala"
		break;
#line 11 "../lib/Widgets/TimePicker.vala"
		case GRANITE_TIME_PICKER_TIME_PROPERTY:
#line 11 "../lib/Widgets/TimePicker.vala"
		g_value_set_boxed (value, granite_time_picker_get_time (self));
#line 11 "../lib/Widgets/TimePicker.vala"
		break;
#line 2585 "TimePicker.c"
		default:
#line 11 "../lib/Widgets/TimePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 11 "../lib/Widgets/TimePicker.vala"
		break;
#line 2591 "TimePicker.c"
	}
}

static void
_vala_granite_time_picker_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	GraniteTimePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_TYPE_TIME_PICKER, GraniteTimePicker);
#line 11 "../lib/Widgets/TimePicker.vala"
	switch (property_id) {
#line 11 "../lib/Widgets/TimePicker.vala"
		case GRANITE_TIME_PICKER_FORMAT_12_PROPERTY:
#line 11 "../lib/Widgets/TimePicker.vala"
		granite_time_picker_set_format_12 (self, g_value_get_string (value));
#line 11 "../lib/Widgets/TimePicker.vala"
		break;
#line 11 "../lib/Widgets/TimePicker.vala"
		case GRANITE_TIME_PICKER_FORMAT_24_PROPERTY:
#line 11 "../lib/Widgets/TimePicker.vala"
		granite_time_picker_set_format_24 (self, g_value_get_string (value));
#line 11 "../lib/Widgets/TimePicker.vala"
		break;
#line 11 "../lib/Widgets/TimePicker.vala"
		case GRANITE_TIME_PICKER_TIME_PROPERTY:
#line 11 "../lib/Widgets/TimePicker.vala"
		granite_time_picker_set_time (self, g_value_get_boxed (value));
#line 11 "../lib/Widgets/TimePicker.vala"
		break;
#line 2623 "TimePicker.c"
		default:
#line 11 "../lib/Widgets/TimePicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 11 "../lib/Widgets/TimePicker.vala"
		break;
#line 2629 "TimePicker.c"
	}
}

